<?php

namespace Contabilidade\Logic\Balancete;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Setforms2\Shared\Registry;


/**
 * Class Balancete
 * @package Contabilidade\Logic\Balancete\Balancete
 */
class Balancete
{
    /**
     * @param $empresa
     * @param $containicial
     * @param $contafinal
     * @param $datainicial
     * @param $datafinal
     * @param $nivel
     * @throws \Exception
     */
    public static function geraBalancete($empresa, $containicial, $contafinal, $datainicial, $datafinal, $nivel)
    {
        try{
            $nrbalancete = '';
            $procedure = new Procedure('BALANCETE_OFICIAL');
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $empresa, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTINI', Param::PARAM_INPUT, $containicial, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCONTFIN', Param::PARAM_INPUT, $contafinal, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAINIC', Param::PARAM_INPUT, $datainicial, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DATAFIN', Param::PARAM_INPUT, $datafinal, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NIVEL', Param::PARAM_INPUT, $nivel, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRBALANCETE', Param::PARAM_OUTPUT, $nrbalancete, Param::PARAM_TYPE_INT, 12));
            $nrbalancete = $procedure->call();
            return $nrbalancete['P_NRBALANCETE'];
        }
        catch(\Exception $e){
            throw $e;
        }
    }

    public static function excluirRelatorio()
    {
        try {
            $nrbalancete = tk_get_field_value('NRBALANCETE');
            $nrorg = tk_get_field_value('NRORG');
            $balancetes = \Contabilidade\Entities\Balancete::findByNrbalanceteAndNrorg($nrbalancete, $nrorg);
            foreach($balancetes as $balancete)
                $balancete->delete();
            Registry::getEntityManager()->flush();
        }catch (\Exception $e)
        {
            throw $e;
        }
    }
}
