<?php
namespace Geral\Logic;

use \Geral\Entities\Filial;
use Geral\Repositories\Perfacessparc;
use \Geral\Entities\Operador;
/**
 *
 */
class RecuperarSenha
{
    private $conn;
    private $email;
    private $nrorganizacao;
    private $organizacao;
    private $operador;
/**Rotina para executar a conexão a base de dados, processo semelhante ao da logic de login, foi adotado este metodo para executar a conexão na base SAAS.
 * */
    public function __construct($email)//, $senha)
    {
        $this->email         = $email;
        //$this->senha         = $senha;
    }

    /**
     * Inicializa os objetos de orgnaizacao, filial e operador, alem de validar os dados do usuario.
     *
     * @return bool
     * @throws \Exception
     */
    public function valida()
    {
        $this->loginVirtualPrivateDatabase();
        $this->obterOperador();
        $this->obterOrganizacao();
        return true;
    }

    /**
     * Retorna o objeto de operador.
     *
     * @return \Geral\Entities\Operador
     */
    public function getOperador()
    {
        return $this->operador;
    }

    /**
     * Retorna o objeto de filial.
     *
     * @return \Geral\Entities\Filial
     */
    public function getFilial()
    {
        return $this->filial;
    }

    /**
     * Retorna o objeto de organizacao.
     *
     * @return \Geral\Entities\Organizacao
     */
    public function getOrganizacao()
    {
        return $this->organizacao;
    }

    /**
     * @throws \Geral\Exceptions\OrganizacaoNaoEncontrada
     * @return \Geral\Entities\Organizacao
     */
    private function obterOrganizacao()
    {
        $this->organizacao = $this->operador->getOrgtrab();
    }


    /**
     * Retorna o objeto de operador a partir do email
     *
     * @throws Login\Exceptions\OperadorNaoEncontrado
     */
    private function obterOperador()
    {
        /** @var $operador \Geral\Entities\Operador */
        $this->operador = \Geral\Entities\Operador::findOneByDsemailoperAndIdoperativo($this->email,'A');
    }



    public function getUserLoginConnection() {
        $host = \Setforms2\Shared\Config::getInstance()->getConnectionHost();
        $serviceName = \Setforms2\Shared\Config::getInstance()->getConnectionServicename();
        $loginUser = \Setforms2\Shared\Config::getInstance()->getConnectionLoginuser();
        $loginPassword = \Setforms2\Shared\Config::getInstance()->getConnectionLoginpassword();
        $loginPassword = \Setforms2\Shared\Util\Util::decrypt($loginPassword);

        if (!$this->conn) {
            $conn = new \Doctrine2\DBAL\Driver\OCI8\OCI8Connection($loginUser, $loginPassword, "//$host/$serviceName");
            $this->conn = $conn;
        }
        return $this->conn;
    }

    /**
     * Retorna a senha com a criptografia delphi.
     *
     * @throws \Exception
     * @return string
     */
    public function _retornaSenhaCriptografada() {
        // verificar se o servidor permite o acesso a esta url
        $url = 'https://www.security.teknisa.com/comwebservice/service.asmx?wsdl';

        $opcoes = array(
            'encoding'    => 'ISO-8859-1',
            'trace'       => true,
            'exceptions'  => true,
            'compression' => SOAP_COMPRESSION_ACCEPT | SOAP_COMPRESSION_GZIP,
        );

        $argumentos = array(
            new \SoapVar($this->senha, XSD_STRING, 'string', "http://www.w3.org/2001/XMLSchema")
        );

        $parametros = array(
            'rdm'    => 'Bib_Html.rdmDBGeralHtm',
            'method' => 'GetCriptoPass',
            'args'   => $argumentos,
        );
        try {
            $client = new \SoapClient($url, $opcoes);
            $retorno = $client->executeCOMMethod($parametros);
            $cryptoPassword = $retorno->executeCOMMethodResult;
        } catch (\SoapFault $e) {
            throw new \Exception($e->getMessage());
        }

        return $cryptoPassword;

    }

    /**
     * @throws \Exception
     * @return mixed
     */
    private function loginVirtualPrivateDatabase()
    {
        if (\Setforms2\Shared\Config::getInstance()->getProjectUsavpd() != 'true') {
            return;
        }
        $operador = $this->getVPDOperadorOrganizacao();
        $this->validaVPDOperador($operador);

        tk_set_env_var('USUARIO_VPD', 'USR_ORG_' . $this->nrorganizacao);

    }


    /**
     * @return mixed
     */
    public function getPerfilacesso()
    {
        return $this->perfilacesso;
    }



    /**
     * @return mixed
     */
    private function getVPDOperadorOrganizacao()
    {
        $conn = $this->getUserLoginConnection();
        $sql = "SELECT CDOPERADOR, NRORGTRAB FROM OPERADOR WHERE DSEMAILOPER = '{$this->email}'";
        $operador = $conn->query($sql)->fetch(\Doctrine2\DBAL\Driver\PDOConnection::FETCH_ASSOC);
        $this->nrorganizacao = $operador['NRORGTRAB'];
        return $operador;
    }

    /**
     * @param $operador
     * @throws \Exception
     */
    private function validaVPDOperador($operador)
    {
        if (!$operador || !$operador['CDOPERADOR']) {
            throw new \Exception('Operador não encontrado.');
        }
        if (!is_numeric($operador['NRORGTRAB'])) {
            throw new \Exception('Organização de trabalho não parametrizada, contacte o administrador.');
        }
    }

    public static function getUsuarioVPD() {
        return tk_get_env_var('USUARIO_VPD');
    }

    /**
     * @return mixed
     */
    public function getSenha()
    {
        return $this->senha;
    }


    /**
     * Envia o email com a nova senha gerada
     */
    public function enviaEmail(){

        $operador = Operador::findOneByDsemailoper($this->email);

        if (($operador instanceof Operador !== false)&&($this->valida())) {
            $email    = $operador->getDsemailoper();
            $senha    = rand(100000, 999999);
            $assunto  = 'Recuperação de acesso';
            $mensagem = '<img width = "152" height = "45" dfsrc="http://www.pebbian.com/wp-content/uploads/2014/04/pebbian_logo_horizontal_completa_site.png" src="http://www.pebbian.com/wp-content/uploads/2014/04/pebbian_logo_horizontal_completa_site.png"/>'
                .'<br/><br/><strong>RECUPERAÇÃO DE SENHA</strong><br/>'
                .'Prezado(a) '.$operador->getNmoperador().', sua nova senha foi gerada com sucesso!'
                .'<br/><br/><strong>Usuário: </strong> '.$email
                ."<br/><strong>Senha: </strong> ".$senha
                ."<br/><br/><br/>Este email é gerado automaticamente, não havendo necessidade de resposta.";
            $senhaBD  = md5($senha);
            $operador->setCdsenhaoperweb($senhaBD);
            $destinatarios = array($email);
            $nomeRemetente = 'Pebbian Tec em Software Mobile ERP';
            $remetente     = "sac@pebbian.com";

            $db = \Setforms2\Runtime\Connection::getInstance();
            $db->getConn()->beginTransaction();

            try {
                $envio = \Setforms2\Shared\Notifier::factory();
                $notification = new \Setforms2\Shared\Business\Notification();

                $notification->setSubject($assunto);
                $notification->setFrom($remetente);
                $notification->setName($nomeRemetente);
                $notification->setTo($destinatarios);
                $notification->setBody($mensagem);
                $envio->setNotificationBusiness($notification);

                $envio->send();
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $operador->persist();
                $connection->flush();
                $db->getConn()->commit();
            } catch (\Exception $e) {
                throw $e;
            }
        } else {
            throw new \Exception('Operador não encontrado.');
        }
    }
/* Valida se o email do operador é valido.
 * */
    public function validaDsemailoper(){
        $valida = $this->valida();
        $operador     = Operador::findOneByDsemailoper($this->email);
        if (($operador instanceof Operador === false)&&($valida!==true)) {
            return false;
        }
        else{
            return true;
        }
    }

}