/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MARC                                                     */
/* Tabela : MARCA                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 27/04/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MARC
BEFORE INSERT OR UPDATE OR DELETE
ON MARCA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMARC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMARCA,0) <> NVL(:NEW.CDMARCA,0)) OR
         (NVL(:OLD.NMMARCA,0) <> NVL(:NEW.NMMARCA,0)) THEN
         :NEW.DTULTATUMARC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MARCA', '', 'CDMARCA='||:OLD.CDMARCA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MARCA MODIFY DTULTATUMARC DEFAULT SYSDATE
/
