var Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller = function(General, ScreenService, templateManager, Utilities, ZhFilterPreferences, MessageService) {

    var dayOfWeek = null;
    var self = this;

    this.openFilterAction = function() {
        var popupWidget = templateManager.container.getWidget('widget_filter_poupup');
        ScreenService.openPopup(popupWidget);
        popupWidget.newRow();
        if (popupWidget.inEditMode()) {
            popupWidget.newRow = function() {};
        }
    };
    this.onEnter = function(widget) {
        this.verificaProjectCorp(widget);
        ZhFilterPreferences.openFilterWidget(widget);
     
    };
    
    this.setCustomFilterRow = function(args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    };
    
    this.filterSolicitaGrid = function(args) {
        var widget = args.owner;
        if (widget.isValid()) {
            this.createGridFilter(args);
            this.setStripeValues(widget);
            ScreenService.closePopup();
            widget.activate();
        }
    };
    
    this.fieldDependente = function(field) {
        if (field.widget.getField('NMFILIAL').value() === "") {
            field.widget.getField('NRAUTOFORN').readOnly = true;
            field.widget.getField('T_NRAUTOFORN').readOnly = true;
            field.widget.getField('NRAUTOFORN').clearValue();
        } else {
            field.widget.getField('NRAUTOFORN').clearValue();
            field.widget.getField('NRAUTOFORN').readOnly = true;
            field.widget.getField('T_NRAUTOFORN').checked = true;
            field.widget.getField('T_NRAUTOFORN').value('T');
            field.widget.getField('T_NRAUTOFORN').readOnly = false;
        }

    };

    this.verificaPermissao = function(widget) {

        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/crud/permissao_operador', 'FilterData', [{
            'name': 'P_CDOPERADOR',
            'operator': '=',
            'value': getLocalVar('CDOPERADOR')
        }]).then(function(callback) {
            if (callback && callback.dataset && callback.dataset.permissao_operador) {
                var permissao = callback.dataset.permissao_operador;
                var permissaoEncerrar = false;
                var permissaoCancelar = false;
                
                if (permissao.length) {
                   if (permissao[0].IDAUTGRUPOP == 'CAAF') {
                       permissaoCancelar = true;
                       if (permissao[1].IDAUTGRUPOP) {
                            permissaoEncerrar = true;
                        }
                   }else if(permissao[0].IDAUTGRUPOP == 'ENAF'){
                       permissaoEncerrar = true;
                   }
                }
                
                widget.getAction('cancelar').isVisible = permissaoCancelar;
                widget.getAction('encerrar').isVisible = permissaoEncerrar;

            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
        
    };
    
    this.setStripeValues = function(widget){
        var dataAf;
        var dataEntrega;

        var widgetFiltro = widget.appliedFilter.FILTER_ROW;
        var widgetStripe = widget.container.getWidget('FILTER');
            
            if (!widgetFiltro.DATA_AF.start) {
                dataAf = ScreenService.i18n('Todas');
                widgetStripe.getField('AFFIM').isVisible = false;
                widgetStripe.getField('AFINI').label =  ScreenService.i18n('Data da AF: ') + dataAf;
            } else {
                widgetStripe.getField('AFFIM').isVisible = true;
                widgetStripe.getField('AFINI').label = ScreenService.i18n('Data Inicial AF: ') + widgetFiltro.DATA_AF.start;
                widgetStripe.getField('AFFIM').label = ScreenService.i18n('Data Final AF: ') + widgetFiltro.DATA_AF.end;
            }

            if (!widgetFiltro.DATA_ENT.start) {
                dataEntrega = ScreenService.i18n('Todas');
                widgetStripe.getField('ENTREGAFIM').isVisible = false;
                widgetStripe.getField('ENTREGAINI').label = ScreenService.i18n('Data de Entrega: ') + dataEntrega;
            } else {
                widgetStripe.getField('ENTREGAFIM').isVisible = true;
                widgetStripe.getField('ENTREGAINI').label = ScreenService.i18n('Data Inicial de Entrega: ') + widgetFiltro.DATA_ENT.start;
                widgetStripe.getField('ENTREGAFIM').label = ScreenService.i18n('Data Final de Entrega: ') + widgetFiltro.DATA_ENT.end;
            }
    };

    this.validaData = function(dataInicial, dataFinal) {

        if (moment(dataFinal, 'DD/MM/YYYY') < moment(dataInicial, 'DD/MM/YYYY')) {
            MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            return false;
        }
        return true;
    };

    this.concatenaUnidade = function(widget) {
        if (widget.appliedFilter.FILTER_ROW.CDFILDEST === '') {
            widget.appliedFilter.FILTER_ROW.UNIDADE = 'T';
            return widget.appliedFilter.FILTER_ROW.UNIDADE;
        } else {

            widget.appliedFilter.FILTER_ROW.UNIDADE = [widget.appliedFilter.FILTER_ROW.CDFILDEST].join('_');
            return widget.appliedFilter.FILTER_ROW.UNIDADE;
        }
    };

    this.concatenaNumeroAF = function(row) {
        if (row.NRAUTOFORN === '') {
            row.AF = 'T';
            return row.AF;
        } else {
            row.AF = row.NRAUTOFORN.join('_');
            return row.AF;
        }
    };

    this.setValorAgrupamento = function(row) {
        if (row.NMAGRUPFILI === '') {
            row.AGRUPAMENTO = 'T';
            return row.AGRUPAMENTO;
        } else {
            row.AGRUPAMENTO = row.CDAGRUPFILI;
            return row.AGRUPAMENTO;
        }
    };

    this.setValorDataEntrega = function(row) {
        if ((!row.DATA_ENT) || (row.DATA_ENT.start === '')){
            row.DATAENT = 'T';
            return row.DATAENT;
        } else {
            row.DATAENT = '';
            return row.DATAENT;
        }
    };

    this.setValorDataAF = function(row) {
        if ((!row.DATA_AF) || (row.DATA_AF.start === '')) {
            row.DATAAF = 'T';
            return row.DATAAF;
        } else {
            row.DATAAF = '';
            return row.DATAAF;
        }
    };

    this.limpaField = function(field) {
        if(field.name === 'NMAGRUPFILI'){

            field.widget.getField('CDFILDEST').clearValue();
           // field.widget.getField('NMFILLANC').clearValue();
            field.widget.currentRow.CDFILDEST = '';
            //field.widget.currentRow.NMFILLANC = '';
        }
        if(field.name === 'CDFILDEST' || field.name === 'NMAGRUPFILI' || field.name === 'DATA_AF' || field.name === 'DATA_ENT'){

            field.widget.getField('NRAUTOFORN').clearValue();
            field.widget.currentRow.NRAUTOFORN = '';
            
        }
    };
    
    this.verificaProjectCorp = function(owner){
        
        if(window.projectCorp){
            owner.getField("CDFILDEST").filterProperties.readOnly = false;
        }
        else{
            owner.getField("CDFILDEST").filterProperties.readOnly = true;
        }
    };
    this.validaProdutoFinal = function(row) { 
        var prod;
        if(row.CDPRODFIN === undefined || row.CDPRODFIN === "") {
            prod = "";
        } else {
            var aux = 'ZZZZZZZZZZ';
            var str = row.CDPRODFIN;
            prod = str + aux.substr(0, aux.length - str.length); 
        } 
        return prod;
    };
   
    this.validaProduto = function(prodInicial, prodFinal) {
        if(prodInicial && prodFinal){
            if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
                MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
                return false;
            }
        }

        return true;
    }; 
    this.setProductIntervalFilterOnFilterPopup = function(args, field){
        
        var filterPopupCurrentRow = args.row;
        if(!(self.validaProduto(filterPopupCurrentRow.CDPRODINI, filterPopupCurrentRow.CDPRODFIN))){
            if(field.name == 'PRODINI'){
                filterPopupCurrentRow.CDPRODINI = '';
                filterPopupCurrentRow.PRODINI = '';
            }else {
                filterPopupCurrentRow.CDPRODFIN = '';
                filterPopupCurrentRow.PRODFIN = '';
            }
        }
    };
    this.readOnlyProduto = function(widget) {
         if(!widget.currentRow.CDPRODINI && !widget.currentRow.CDPRODFIN) {
             widget.getField('PRODINI').validations = {};
             widget.getField('PRODFIN').validations = {};
        } else {
            widget.getField('PRODINI').validations = {"required": true};
            widget.getField('PRODFIN').validations = {"required": true};
        }
    };
  
    this.createFilialFilter = function(field) {
        var row = field.widget.currentRow;
        var widget = field.widget;
        var filial = field.widget.getField('CDFILDEST');
        var filtro = [
            {
                'name': 'P_CDOPERADOR',
                'operator': '=',
                'value': getLocalVar('CDOPERADOR')
            },
            {
                'name': 'P_CDGRUPFILI',
                'operator': '=',
                'value': row.CDAGRUPFILI
            },
            {
                "operator": "ORDER_BY",
                "name": [{
                    "name": "CDFILIAL",
                    "direction": "ASC"
                }]
            }
        ];
        filial.dataSourceFilter = filtro;
        if (!row.NMAGRUPFILI) {
            filial.dataSource.name = "cmp_fornecimento_autorizacaoFornecimento#/crud/cmp07200_alteracao_automatica_de_situacao_da_af_unidade_sem_agrupamento";
            
        } else {
            
            filial.dataSource.name = "cmp_fornecimento_autorizacaoFornecimento#/crud/cmp07200_alteracao_automatica_de_situacao_da_af_unidade_com_agrupamento";
        
        }
        filial.reload();
    };

    this.createNumeroFilter = function(field) {
        var row = field.widget.currentRow,
            dt_ent_start = (row.DATA_ENT) ? row.DATA_ENT.start : '',
            dt_ent_end = (row.DATA_ENT) ? row.DATA_ENT.end : '',
            dt_af_start = (row.DATA_AF) ? row.DATA_AF.start : '',
            dt_af_end = (row.DATA_AF) ? row.DATA_AF.end : '';
       
        var cdfildest = row.CDFILDEST ? Array.isArray(row.CDFILDEST) ? row.CDFILDEST.join('_') : 'T' : 'T';
        
        var filtro = [
        	{
                "operator": "ORDER_BY",
                "name": [{
                    "name": "NRAUTOFORN",
                    "direction": "ASC"
                }    
                ]
            },
        	{
                'name': 'P_CDFILDEST',
                'operator': '=',
                'value': cdfildest
            },
            {
                'name': 'P_CDSUBGRUFILI',
                'operator': '=',
                'value': self.setValorAgrupamento(row)
            },
            {
                'name': 'P_DTINIENTR',
                'operator': '=',
                'value': dt_ent_start
            },
            {
                'name': 'P_DTFINENTR',
                'operator': '=',
                'value': dt_ent_end
            },
            {
                'name': 'P_TDAENTREGA',
                'operator': '=',
                'value': self.setValorDataEntrega(row)
            },
            {
                'name': 'P_DTINIAUTOFORN',
                'operator': '=',
                'value': dt_af_start
            },
            {
                'name': 'P_DTFINAUTOFORN',
                'operator': '=',
                'value': dt_af_end
            },
            {
                'name': 'P_TDTAUTOFORN',
                'operator': '=',
                'value': self.setValorDataAF(row)
            },
            {
                'name': 'P_CDOPERADOR',
                'operator': '=',
                'value': 'OPERADOR_LOGADO'
            }
           
        ];
        
        field.dataSourceFilter = filtro;
        General.callRestEngine('cmp_fornecimento#/crud/cmp07200_alteracao_automatica_de_situacao_da_af_numero', 'FilterData', filtro).then(function(callback) {
                var retorno = callback.dataset.cmp07200_alteracao_automatica_de_situacao_da_af_numero;
                if (!retorno.length) {
                    MessageService.showMessageByCode("SEM_AF_PARA_FILIAL_DEST");
                }

            }, function(err) {
                ScreenService.showMessage(err.data.error);
        });
        field.reload();
    };

    this.createGridFilter = function(args) {
        var widget = args.owner,
    	    filterCurrentRow = angular.copy(widget.appliedFilter.FILTER_ROW),
            cdfildest = filterCurrentRow.CDFILDEST ? Array.isArray(filterCurrentRow.CDFILDEST) ? filterCurrentRow.CDFILDEST.join('_') : 'T' : 'T',
            dt_ent_start = filterCurrentRow.DATA_ENT.start ? filterCurrentRow.DATA_ENT.start : null,
            dt_ent_end = filterCurrentRow.DATA_ENT.end ? filterCurrentRow.DATA_ENT.end : null,
            dt_af_start = filterCurrentRow.DATA_AF.start ? filterCurrentRow.DATA_AF.start : null,
            dt_af_end = filterCurrentRow.DATA_AF.end ? filterCurrentRow.DATA_AF.end : null;

            filterCurrentRow.UNIDADE = this.concatenaUnidade(widget);
            filterCurrentRow.AGRUPAMENTO = self.setValorAgrupamento(filterCurrentRow);
            
            args.e.preventDefault();
    
            
                var filter = [
                    {
                        'name': 'P_CDFILDEST',
                        'operator': '=',
                        'value': cdfildest
                    },
                    {
                        'name': 'P_DTINIENTR',
                        'operator': '=',
                        'value': dt_ent_start
                    },
                    {
                        'name': 'P_DTFINENTR',
                        'operator': '=',
                        'value': dt_ent_end
                    },
                    {
                        'name': 'P_TDTENTREGA',
                        'operator': '=',
                        'value': self.setValorDataEntrega(filterCurrentRow)
                    },
                    {
                        'name': 'P_NRAUTOFORN',
                        'operator': '=',
                        'value': self.concatenaNumeroAF(filterCurrentRow)
                    },
                    {
                        'name': 'P_DTFINAUTOFORN',
                        'operator': '=',
                        'value': dt_af_end
                    },
                    {
                        'name': 'P_DTINIAUTOFORN',
                        'operator': '=',
                        'value': dt_af_start
                    },
                    {
                        'name': 'P_TDTAUTOFORN',
                        'operator': '=',
                        'value': self.setValorDataAF(filterCurrentRow)
                    },
                    {
                        'name': 'P_CONSAFEXP',
                        'operator': '=',
                        'value': filterCurrentRow.AFEXPIRADA
                    },
    				{
    					"operator": "ORDER_BY",
    					"name": [
    						{
    							"name": "DTPROGENTAF",
    							"direction": "ASC"
    						}    
    					]
    				}
                ];
                
                
                if( !Util.isEmptyOrBlank(filterCurrentRow.PRODINI) && !Util.isEmptyOrBlank(filterCurrentRow.PRODFIN) ){
                    filter.push(
                        {
                            'name': 'P_CDPRODINI',
                            'operator': '=',
                            'value': filterCurrentRow.CDPRODINI
                        },
                        {
                            'name': 'P_CDPRODFIN',
                            'operator': '=',
                            'value': this.validaProdutoFinal(filterCurrentRow)
                        }
                    );
                }
                else
                {
                    filter.push(
                        {
                            'name': 'P_TPRODUTOS',
                            'operator': '=',
                            'value': 'T'
                        }
                    );
                }
                widget.dataSourceFilter = filter;
                widget.reload();
         

        
        
             
    };

    this.actionButtons = function(widget, idbaixaaf) {
    
        for (var i = 0; i < widget.getCheckedRows().length; i++) {
            widget.getCheckedRows()[i].IDBAIXAAF = idbaixaaf;
            widget.getCheckedRows()[i].DT = widget.getCheckedRows()[i].DTPROGENTAF.split(" ")[0];
        }
        var row = widget.getCheckedRows();

        if (idbaixaaf === 3) {
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/cmp07200_alteracao_automatica_de_situacao_da_af/baixar', 'DataSet', row).then(function() {
                widget.reload();
                widget.unSelectAll();
                MessageService.showMessageByCode("DOWNLOAD_SUCCESS");

            }, function(err) {

                ScreenService.showMessage(err.data.error);
            });

        } else {
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/cmp07200_alteracao_automatica_de_situacao_da_af/cancelarEncerrar', 'DataSet', row).then(function() {
                widget.reload();

                if (idbaixaaf === 5) {
                    widget.unSelectAll();
                    MessageService.showMessageByCode("AF_CANCELADA_SUCCESS");
                } else {
                    widget.unSelectAll();
                    MessageService.showMessageByCode("AF_ENCERRADA_SUCCESS");
                }

            }, function(err) {

                ScreenService.showMessage(err.data.error);
            });

        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller', Cmp07200_AlteracaoAutomaticaDeSituacaoDaAf_Controller);
});