function cmp03100_lancamento_de_solicitacao_de_comprasController(General, ScreenService, templateManager, ZhFilterPreferences, Utilities, maskEngine, ZhUtil, $http, metaDataFactory, Parametros, MessageService, ZHPromise) {
    
    const permissionsArray = {
        'INCLUIR_DTENTREGA'     : false,
        'EXCLUIR_DTENTREGA'     : false,
        'INCLUIR_PRODUTO'       : false,
        'ALTERAR_PRODUTO'       : false,
        'EXCLUIR_PRODUTO'       : false,
        'EXCLUIR_SOLICITACAO'   : false,
        'AUMENTAR_QUANTIDADE'   : false,
        'DIMINUIR_QUANTIDADE'   : false,
        'percentAumentar'       : undefined,
        'percentDiminuir'       : undefined,
        'APROVAR_SOLICITACAO'   : false
        
    };
    var self = this;
    var days = [];
    
    var nrOrg = "";
    
    this.onEnterOnceWidgetPrincipal = function(args) {
        
        nrOrg = getLocalVar('NRORG');
        
        ScreenService.showLoader();
        
        var widget = args.owner;
        
        this.setFieldsGerais(widget);
        
        var dataSourceFilter = [
            { 
                "name": "P_STIDIOMA", 
                "operator": "=", "value": 'P'
            },
            { 
                "name": "NRORG", 
                "operator": "=", 
                "value": nrOrg
            }
        ];
        
        var rowsToSet = {};
		rowsToSet.defaultFilter = widget.dataSourceFilter;
		
		if(nrOrg) {
		    loadAndOpenFilter(widget, rowsToSet, dataSourceFilter);
		} else {
		    dataSourceFilter[1].value = 1; //provisório, necessário carregar o NRORG de outra forma, pois o getLocalVar não funciona a primeira vez!
		    loadAndOpenFilter(widget, rowsToSet, dataSourceFilter);
		}
        
        /**
         * 
         * Função criada para verificar se o operador logado no sistema possue acesso
         * a tela de Aprovação/Desaprovação de Solicitação, caso possua acesso as
         * actions de aprovação e desaprovação ficarão habilitadas
         *
         */
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getPermissaoAprovReprovacao','Row', {}).then(function(callback){
            permissionsArray.APROVAR_SOLICITACAO = callback.dataset.dataset.length > 0;
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    function loadAndOpenFilter(widget, rowsToSet, dataSourceFilter) {
        General.callRestEngine('cmp_solicitacao_relatorios#/filtraCusto', 'FilterData', dataSourceFilter).then(function(callback) {
            widget.getField('NMTIPOCUSTO').dataSource.data = callback.dataset.custo;
            widget.currentRow.NMTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO;
            rowsToSet.CDTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].CDTIPOCUSTO;
            rowsToSet.NMTIPOCUSTO = widget.getField('NMTIPOCUSTO').dataSource.data[0].NMTIPOCUSTO;
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(opened => {
                ScreenService.hideLoader();
            }).catch(error => {
                console.log(error);
                ScreenService.hideLoader();
            });
            //Utilities.startFilter(args.owner);
        }, function(err) {
			ScreenService.showMessage(err.data.error);
		});
    }
    
    this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};
    
    this.limpaFieldUnidade = function(field) {
        const nmfilialField = field.widget.getField('NMFILIAL');
        
        nmfilialField.clearValue();
    };
    
    this.setDataSourceFilter = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDTIPOCUSTO",
		        "operator": "=",
		        "value": filterRow.CDTIPOCUSTO
		    },
		    {
		        "name": "P_CDFILIAL",
		        "operator": "=",
		        "value": concatArrayForParams(filterRow.NMFILIAL, '')
		    },
		    {
		        "name": "P_DTSOLINI",
		        "operator": "=",
		        "value": filterRow.DTSOLCMP.start
		    },
		    {
		        "name": "P_DTSOLFIM",
		        "operator": "=",
		        "value": filterRow.DTSOLCMP.end
		    },
		    {
		        "name": "P_TSOLICITA",
		        "operator": "=",
		        "value": verifyDateFieldValues(filterRow, 'DTSOLCMP')
		    },
		    {
		        "name": "P_ENTRINI",
		        "operator": "=",
		        "value": filterRow.DTENTREGA.start
		    },
		    {
		        "name": "P_ENTRFIM",
		        "operator": "=",
		        "value": filterRow.DTENTREGA.end
		    },
		    {
		        "name": "P_TENTREGA",
		        "operator": "=",
		        "value": verifyDateFieldValues(filterRow, 'DTENTREGA')
		    },
		    {
		        "name": "P_COMPRADOR",
		        "operator": "=",
		        "value": filterRow.COMPRADOR
		    },
		    {
		        "name": "P_TCOMPRADOR",
		        "operator": "=",
		        "value": concatArrayForParams(filterRow.COMPRADOR, 'T')
		    },
		    {
		        "name": "P_CDOPERADOR",
		        "operator": "=",
		        "value": getLocalVar('CDOPERADOR')
		    },
		    {
		        "name": "P_CDDESTSOLI",
		        "operator": "=",
		        "value": filterRow.CDDESTSOLI
		    },
		    {
		        "name": "P_TCDDESTSOLI",
		        "operator": "=",
		        "value": !Util.isEmptyOrBlank(filterRow.CDDESTSOLI) ? '' : 'T'
		    },
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "DTSOLCMP",
                        "direction": "DESC"
                    },
                    {
                        "name": "NRSOLICMP",
                        "direction": "DESC"
                    }
                ]
            }
		];
		
		widget.reload().then(function(callback) {
		    setArrayPermissoes();
            widget.activate();
		});
		
    };
    
    function setArrayPermissoes() {
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getPermissoes','Row', {}).then(function(callback){
            const permissoes = callback.dataset.permissoes;
            
            if(permissoes){
                permissoes.forEach(function (value){
                    permissionsArray[value.IDAUTLANCSOLI] = true;
                    
                    if(value.IDAUTLANCSOLI == 'AUMENTAR_QUANTIDADE'){
                        permissionsArray.percentAumentar    = value.PEALTEQTDESOLI;
                    }
                    if(value.IDAUTLANCSOLI == 'DIMINUIR_QUANTIDADE'){
                        permissionsArray.percentDiminuir    = value.PEALTEQTDESOLI;
                    }
                });
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    function verifyDateFieldValues(filterRow, fieldName) {
    	//Selecionando o campo data de acordo com o fieldName enviado
    	const startCampoData = filterRow[fieldName].start;
    	const endCampoData = filterRow[fieldName].end;
        
        return (startCampoData && endCampoData) ? '' : 'T';
    }
    
    /**
     * Retorna a concatenação do array passado pro parâmetro. 
     * 
     * @param {Array} arr - array a ser concanetado.
     * @param {string} defaultValue - Valor a ser retornado caso o arr esteja
     * vazio ou em branco.
     * @returns {string} Array concatenado ou o defaultValue passado por
     * parâmetro. Se não houver defaultValue, retorna 'T'.
     */
    function concatArrayForParams(arr, defaultValue = 'T') {
       return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue;
    }
    
    this.setWidgetAfterMoveRow = function(args) {
        const widget = args.owner;
        const row = widget.currentRow;
        const stripeWidget = templateManager.container.getWidget('stripeWidget');
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        const dadosSolicitacaoWidget = templateManager.container.getWidget("dadosSolicitacao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        stripeWidget.currentRow.NMFILSOLI   = row.NMFILIAL;
        stripeWidget.currentRow.EXTRA       = stripeWidget.getField('EXTRA').options[row.IDSOLEXTRA];
        stripeWidget.currentRow.IDBAIXASOL  = stripeWidget.getField('IDBAIXASOL').options[row.IDBAIXASOL];
        stripeWidget.currentRow.NMDESTSOLI  = row.NMDESTSOLI;
        stripeWidget.currentRow.COMPRADOR   = row.CDOPERADOR ? row.CDOPERADOR +' | '+ row.NMOPERADOR : '';
        stripeWidget.currentRow.IDUTLOPERSOL = row.IDUTLOPERSOL;
    
        dadosSolicitacaoWidget.externalRow = row;
        dadosSolicitacaoWidget.currentRow = row;
        
        produtosWidget.dataSourceFilter = [
			{
				'name': 'P_CDFILSOLI',
				'operator': '=',
				'value': row.CDFILSOLI
			},
			{
				'name': 'P_CDFILLAN',
				'operator': '=',
				'value': row.CDFILLANCA
			},
			{
				'name': 'P_NRSOLICMP',
				'operator': '=',
				'value': row.NRSOLICMP
			},
			{
				'name': 'P_NRTIPOCUSTO',
				'operator': '=',
				'value': row.CDTIPOCUSTO
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "NMPRODUTO",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		const openOnProductTab = true;
		
		if (!widget.currentRow || Util.isEmptyObject(widget.currentRow)) {
            return;
        }
        
        if (ScreenService.isSwipeOpen()) {
            this.abreLancamento(widget, openOnProductTab).then((widgetAtual) => {
               const activeWid = templateManager.container.getActiveWidget();
               if(templateManager.container.getWidget("inclusaoSolicitacaoPrincipal").enabled && activeWid.name === "inclusaoSolicitacaoPrincipal") {
                   templateManager.container.getWidget("dadosSolicitacao").enabled = false;
               }
            });
        } else {
            Utilities.onDoubleClick(this.abreLancamento, [ widget, openOnProductTab ]);
        }
    };
    
    function setProdStripeFooter(data) {
        const prodStripeFooter = templateManager.container.getWidget("prodStripeFooter");
        
        prodStripeFooter.currentRow.TOTALPROD = [...new Set(data.dataset.itens_solicitacao.map(value => value.CDPRODUTO))].length;
		prodStripeFooter.currentRow.TOTALENTREGA = data.dataset.itens_solicitacao.length;
    }
    
    function verifyPermission(row, operation) {
        const blockChange = (row.IDTIPLAN === 'A' || row.IDTIPLAN === 'C') && row.IDBLOQALTSOLAUT === 'S';
        
        if(blockChange) {
            return permissionsArray[operation];
        } 
        
        return true;
    }
    
    function verifyOperatorPermission(row) {
        if(row.IDUTLOPERSOL === 'S') {
            return (row.CDOPERLANC && (getLocalVar('CDOPERADOR') === row.CDOPERLANC));
        }
        
        return true;
    }
    
    function desabilitaActions(widgets){
        widgets.forEach(function(widget){
            widget.actions.forEach(function(action){
                action.isVisible     = false;
                if(action.name == "voltar" || action.name == 'adicionaSolicitacao'){
                    action.isVisible = true;
                }   
            });
        });
        templateManager.container.getWidget('justificativaAlteracao').getAction('voltar').isVisible = true;
    }
    
    this.setVisibleProductsWidget = function() {
        setVisibleProductActionsAndFields();   
    };
    
    function setVisibleProductActionsAndFields() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justAltWidget = templateManager.container.getWidget("justificativaAlteracao");
        
        const deleteAction = produtosWidget.getAction('excluiData');
        const addAction = produtosWidget.getAction('adicionaProduto');
        //const deleteSolicita = solicitacaoWidget.getAction('excluiSolicitacao');
        
        const editSolicita = dadosSolicitacao.getAction('editaSolicitacao');
        const deleteDadosSolicita = dadosSolicitacao.getAction('excluiSolicitacao');
        
        deleteAction.isVisible = true;
        addAction.isVisible = true;
        //deleteSolicita.isVisible = true;
        editSolicita.isVisible = true;
        deleteDadosSolicita.isVisible = true;
        
        produtosWidget.getField('QTSOLIPROD').inlineEditable = "number";
        produtosWidget.getField('QTVOLUITEMSO').inlineEditable = "number";
        produtosWidget.getField('TXOBSITMSOL').inlineEditable = "text";
        
        if(!verifyOperatorPermission(solicitacaoWidget.currentRow)) {
            deleteAction.isVisible = false;
            addAction.isVisible = false;
            //deleteSolicita.isVisible = false;
            editSolicita.isVisible = false;
            deleteDadosSolicita.isVisible = false;
            
            delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
            delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
            delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
        } else {
            if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
                if(produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length > 0) {
                    addAction.isVisible = solicitacaoWidget.currentRow.IDIMPINCSOLAPR === 'S';
                    deleteAction.isVisible = solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S';
                    //deleteSolicita.isVisible = solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S';
                    editSolicita.isVisible = solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S';
                    deleteDadosSolicita.isVisible = solicitacaoWidget.currentRow.IDPERALTSAPR[1] === 'S';
                } else {
                    deleteAction.isVisible = true;
                    addAction.isVisible = true;
                    //deleteSolicita.isVisible = true;
                    editSolicita.isVisible = true;
                    deleteDadosSolicita.isVisible = true;
                }
            } else {
                deleteAction.isVisible = (verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_PRODUTO') && verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_DTENTREGA'));
                addAction.isVisible = (verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_PRODUTO') && verifyPermission(solicitacaoWidget.currentRow, 'INCLUIR_DTENTREGA'));
                //deleteSolicita.isVisible = verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_SOLICITACAO');
                deleteDadosSolicita.isVisible = verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_SOLICITACAO');
                                        
                if(!verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE') && !verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                    delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                    delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                    delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
                }                                        
            }
        }
        
        if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S'){
            produtosWidget.getField('IDSOLIAPROV').isVisible = true;
        } else {
            produtosWidget.getField('IDSOLIAPROV').isVisible = false;
        }
        
        if(solicitacaoWidget.currentRow.IDUTQTDEVOLU == 'S'){
            produtosWidget.getField('QTVOLUITEMSO').isVisible = true;
        } else {
            produtosWidget.getField('QTVOLUITEMSO').isVisible = false;
        }
        
        if(solicitacaoWidget.currentRow.IDAUDALTSOL == "S") {
            justAltWidget.enabled = true;
		} else {
		    justAltWidget.enabled = false;
		}
        
        
        produtosWidget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        produtosWidget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        
        solicitacaoWidget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        solicitacaoWidget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S');
        
        /**
         * To do
         * Criar rotina de calculo de media
         * 
         * */
        produtosWidget.getAction('CALCULO_MEDIA').isVisible = false;
        
        templateManager.updateTemplate();
    }
    
    function setActionsVisible(widget) {
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const prodnovoWidget = templateManager.container.getWidget("prodnovo");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const widJustificativa        = templateManager.container.getWidget("justificativaAlteracao");
        
        const widArray = [dadosSolicitacao, produtosWidget, /*widDetalhesProduto,*/ widJustificativa];
        
        if(!verifyOperatorPermission(widget.currentRow)) {
        //if(widget.currentRow.IDUTLOPERSOL === 'S' && (widget.currentRow.CDOPERLANC && widget.currentRow.CDOPERLANC != getLocalVar('CDOPERADOR'))){
            desabilitaActions(widArray);
        } else {
            solicitacaoWidget.getAction('excluiSolicitacao').isVisible = verifyPermission(widget.currentRow, 'EXCLUIR_SOLICITACAO');
            dadosSolicitacao.getAction('excluiSolicitacao').isVisible = verifyPermission(widget.currentRow, 'EXCLUIR_SOLICITACAO');
            
            prodnovoWidget.getAction('adicionaProdNovo').isVisible = verifyPermission(widget.currentRow, 'INCLUIR_PRODUTO');
            prodnovoWidget.getAction('excluiProdNovo').isVisible = verifyPermission(widget.currentRow, 'EXCLUIR_PRODUTO');
            
            produtosWidget.getAction('adicionaProduto').isVisible = verifyPermission(widget.currentRow, 'INCLUIR_PRODUTO');
            produtosWidget.getAction('excluiData').isVisible = verifyPermission(widget.currentRow, 'EXCLUIR_PRODUTO');
        }
        
        solicitacaoWidget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && widget.currentRow.IDUTAPROVSOL === 'S');
        solicitacaoWidget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && widget.currentRow.IDUTAPROVSOL === 'S');
        
        produtosWidget.getAction('aprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && widget.currentRow.IDUTAPROVSOL === 'S');
        produtosWidget.getAction('reprovaSolicitacao').isVisible = (permissionsArray.APROVAR_SOLICITACAO && widget.currentRow.IDUTAPROVSOL === 'S');
    }
    
    function setFieldsVisible(widget) {
        const widDatasAddProduto      = templateManager.container.getWidget('datasAddProduto');
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        if(widget.currentRow.IDUTLOPERSOL == 'S'){
            if(widget.currentRow.CDOPERLANC && widget.currentRow.CDOPERLANC !== getLocalVar('CDOPERADOR')){
                delete produtosWidget.getField('QTSOLIPROD').inlineEditable;
                delete produtosWidget.getField('QTVOLUITEMSO').inlineEditable;
                delete produtosWidget.getField('TXOBSITMSOL').inlineEditable;
            }
        }
        
        if(widget.currentRow.IDAPROVITMSOLGR == 'S'){
            widDatasAddProduto.getField('DTCMPANTERIOR').validations = {"required": true};
        }else{
            delete widDatasAddProduto.getField('DTCMPANTERIOR').validations;
            widDatasAddProduto.getField('DTCMPANTERIOR').isVisible = false;
        }
        
        if(widget.currentRow.IDUTAPROVSOL === 'S'){
            produtosWidget.getField('IDSOLIAPROV').isVisible = true;
           
        }else{
            produtosWidget.getField('IDSOLIAPROV').isVisible = false;
        }
        
        if(widget.currentRow.IDUTQTDEVOLU == 'S'){
            produtosWidget.getField('QTVOLUITEMSO').isVisible = true;
            widDatasAddProduto.getField('QTVOLUITEMSO').isVisible = true;
        }else{
            produtosWidget.getField('QTVOLUITEMSO').isVisible = false;
            widDatasAddProduto.getField('QTVOLUITEMSO').isVisible = false;
        }
    
        templateManager.updateTemplate();
    }
    
    this.filtraUnidades =  function(field) {
        const row = field.widget.currentRow;
        
        field.dataSourceFilter = [
			{
				'name': 'CDOPERADOR',
				'operator': '=',
				'value': getLocalVar('CDOPERADOR')
			},
			{
				'name': 'CDGRUPFILI',
				'operator': '=',
				'value': row.CDGRUPFILI ? row.CDGRUPFILI : ''
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDFILIAL",
                        "direction": "ASC"
                    }
                ]
            }
		];

        field.reload();
    };
    
    this.setDateFieldProperties = function(widget, fieldName) {
        const fieldValidade = widget.getField(fieldName);
    	const currentRowWidget = widget.currentRow;
    	
    	//Selecionando o campo data de acordo com o fieldName enviado
    	const startCampoData = currentRowWidget[fieldName].start;
    	const endCampoData = currentRowWidget[fieldName].end;
        
        //OU Exclusivo - XOR
        if ((startCampoData && !endCampoData) || (!startCampoData && endCampoData)) {
            fieldValidade.validations = {
                "requiredInterval": true
            };
        } else {
            delete fieldValidade.validations;
        }    
    };
    
    this.loadDataSource = function(field) {
        const widget = field.widget;

        General.onClickDependentField(field, {'P_CDFILIAL': concatArrayForParams(widget.currentRow.NMFILIAL, '')});
    };
    
    this.loadEditDataSource = function(field) {
        const widget = field.widget;
        
        General.onClickDependentField(field, { 'P_CDFILIAL': widget.currentRow.CDFILSOLI });
    };
    
    this.adicionaSolicitacaoFiltro = function(widget) {
        const inclusaoSolicitacao = templateManager.container.getWidget("inclusaoSolicitacao");
        const principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        const diasEntrega = templateManager.container.getWidget("DATAS");
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const justificativaAlteracao = templateManager.container.getWidget("justificativaAlteracao");
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        
        tabbedWidget.defaultTab = "inclusaoSolicitacao";
        ScreenService.openSwipe(tabbedWidget);
        inclusaoSolicitacao.isVisible = true;
        inclusaoSolicitacao.activate();
        principal.activate();
        principal.enabled = true;
        principal.isVisible = true;
        principal.template = "widget/form.html";
        diasEntrega.enabled = false;
        diasEntrega.isVisible = true;
        diasEntrega.template = "widget/grid.html";
        principal.edit();
        delete principal.getField("NMPRODINI").validations.required;
        delete principal.getField("NMPRODFIN").validations.required;
        principal.getField("NMPRODINI").reload();
        principal.getField("NMPRODFIN").reload();
        
        principal.currentRow.CDFILIAL = widget.currentRow.CDFILSOLI;
        principal.currentRow.CDFILSOLI = widget.currentRow.CDFILSOLI;
        principal.currentRow.NMFILIAL = widget.currentRow.NMFILIAL;
        principal.currentRow.CDFILIAL = widget.currentRow.CDFILSOLI;
        principal.currentRow.CDFILSOLI = widget.currentRow.CDFILSOLI;
        principal.currentRow.NMFILIAL = widget.currentRow.NMFILIAL;
        principal.currentRow.CDFILCENT = widget.currentRow.CDFILCENTCMP;
        principal.currentRow.NMFILCENT = widget.currentRow.CDFILCENTCMP + " | " + widget.currentRow.NMCENTCMP;
        principal.currentRow.IDUTAPROVSOL = widget.currentRow.IDUTAPROVSOL;
        principal.currentRow.IDPERALTSAPR = widget.currentRow.IDPERALTSAPR;
        principal.currentRow.IDSISDOS = widget.currentRow.IDSISDOS;
        
        dadosSolicitacao.enabled = false;
        produtosWidget.enabled = false;
        justificativaAlteracao.enabled = false;
    };
    
    this.cancelarInclusaoSolicitacao = function(args) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        ScreenService.closePopup();
        
        if(solicitacaoWidget.dataSource.data.length === 0) {
            Utilities.startFilter(solicitacaoWidget);   
        } else {
            solicitacaoWidget.list();
            solicitacaoWidget.activate();
        }
    };
    
    this.setCurrentRowInclusao = function(widget, onEnter) {
        templateManager.container.getWidget("dadosSolicitacao").enabled = false;
        const principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        
        widget.currentRow.NMFILLANCA    = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
        widget.currentRow.CDFILLANCA    = getLocalVar('CDFILIAL');
        widget.currentRow.CDFILSOLI     = templateManager.container.getWidget('solicitacaoWidget').currentRow.CDFILSOLI;
        widget.currentRow.DTSOLCMP      = moment().format('DD/MM/YYYY');
        
        widget.backupRow = angular.copy(widget.currentRow);
        
        setControlDestSoli(principal, onEnter);
    };
    
    function setControlDestSoli(widget, onEnter) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        
        widget.currentRow.CDFILSOLI = widget.currentRow.CDFILIAL;
        //widget.currentRow.NRORG = getLocalVar('NRORG');
        //widget.currentRow.NMFILCENT = widget.currentRow.CDFILCENT + " | " + widget.currentRow.NMFILCENT;
        
        if(!solicitacaoWidget.dataSource.data.length && !onEnter) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validarInclusProdCompra', 'Row', widget.currentRow).then(function(res) {
                const dados = res.dataset.res[0];
                
                if(dados[0] && dados[0].IDUTPRODPREF == "S") {
                    widget.getField('PRODCMP').checked = true;
                    widget.currentRow.PRODCMP = 'S';
                } else {
                    widget.getField('PRODCMP').checked = false;
                    widget.currentRow.PRODCMP = 'N';
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
        
        if(!widget.currentRow.CDFILIAL || widget.currentRow.CDFILIAL == "") {
            widget.getField('NMDESTSOLI').readOnly = true;
            widget.getField('NMDESTSOLI').clearValue();
            widget.currentRow.CDDESTSOLI = "";
            widget.currentRow.NMDESTSOLI = "";
            widget.getField('NMDESTSOLI').reload();
        } else {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validarInclusProdCompra', 'Row', widget.currentRow).then(function(res) {
                const dados = res.dataset.res[0];
                if(dados[0] && dados[0].IDULTDESTSOL == "S") {
                    widget.getField('NMDESTSOLI').dataSourceFilter = [
    			        {
    				        "name": "P_CDFILIAL",
    				        "operator": "=",
    				        "value": widget.currentRow.CDFILIAL
    			        },
    			        {
                            "operator": "ORDER_BY",
                            "name": [
                                {
                                    "name": "CDDESTSOLI",
                                    "direction": "ASC"
                                }
                            ]
                        }
    		        ];
    		        
    		        widget.getField('NMDESTSOLI').reload().then(function(callback) {
                        if(callback.dataset.destsol.length > 0) {
                            widget.getField('NMDESTSOLI').readOnly = false;
                            widget.currentRow.CDDESTSOLI = "";
                            widget.currentRow.NMDESTSOLI = "";
                            widget.getField("NMDESTSOLI").clearValue();
                            widget.getField("NMDESTSOLI").reload();
                        } else {
                            widget.getField('NMDESTSOLI').readOnly = true;
                            widget.getField("NMDESTSOLI").clearValue();
                            widget.currentRow.CDDESTSOLI = "";
                            widget.currentRow.NMDESTSOLI = "";
                            widget.getField("NMDESTSOLI").reload();
                        }
                    });
                } else {
                    widget.getField('NMDESTSOLI').readOnly = true;
                    widget.getField("NMDESTSOLI").clearValue();
                    widget.currentRow.CDDESTSOLI = "";
                    widget.currentRow.NMDESTSOLI = "";
                    widget.getField("NMDESTSOLI").reload();
                }
            });
            
            
            
        }
    }
    
    this.controlaDestinoSolicitacao = function(field, onEnter){
        const widget = field.widget;
        
        setControlDestSoli(widget, onEnter);
    };
    
    this.salvaSolicitacao = function(args) {
        const widget = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        let row = widget.currentRow;
        
        console.log("Row Insert: ", row);
        
        if(validaCamposPreenchidos() && validaProduto() && validaDataInserida()) {
        
            delete row.__rightActions;
            delete row.__leftActions;
        
            row.IDTIPLAN   = 'M';
            row.CDOPERLANC = getLocalVar('CDOPERADOR');
            row.CDOPERADOR = widget.currentRow.CDOPERADOR ? widget.currentRow.CDOPERADOR : null;
            row.CDDESTSOLI = widget.currentRow.CDDESTSOLI ? widget.currentRow.CDDESTSOLI : null;
            row.DSJUSTSOL  = widget.currentRow.DSJUSTSOL  ? widget.currentRow.DSJUSTSOL  : null;
            
            if(row.NRSOLICMP) {
            	row.__isNew = false;
            } else {
            	row.__isNew = true;
            }
            
            return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvaSolicitacao', 'Row', row).then(function(sol) {
                const nSolicita = sol.dataset.sol[0];
        
                row.NRSOLICMP = nSolicita;
                
                widget.template = 'widget/form-view.html';
                widget.view();
                widget.reload();
                General.backOrCancel(args);
                templateManager.container.getWidget("inclusaoSolicitacao").isVisible    = false;
                templateManager.container.getWidget("dadosSolicitacao").enabled         = false;
                templateManager.container.getWidget("produtosWidget").enabled           = false;
                templateManager.container.getWidget("justificativaAlteracao").enabled   = false;
                
                if(!row.CDFILIAL_SOL) {
                    row.CDFILIAL_SOL = "";
                }
                
                if(!(row.NMPRODINI && row.NMPRODFIN)) {
                    return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/getProdutos', 'Row', row).then(function(callback) {
                        var produto = callback.dataset.res[0];
                        row.CDPRODINI = produto[0].MIN_CDPRODUTO;
                        row.CDPRODFIN = produto[0].MAX_CDPRODUTO;
                        
                        return montaListaProdutos(widget ,row);
                    });
                } else {
                    return montaListaProdutos(widget, row);
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    function validaCamposPreenchidos() {
        const widgetPrincipal = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        
        if(widgetPrincipal.isValid()) {
            return true;
        } else {
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            widgetPrincipal.activate();
            return false;
        }
    }
    
    function validaProduto() {
        const widgetPrincipal = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        const row = widgetPrincipal.currentRow;
        
        if(row.CDPRODINI && !row.CDPRODFIN) {
            MessageService.showMessageByCode("PRODUTO_FINAL_N_INFORMADO", {}, {
                type: 'INFORMATION'
            });
            widgetPrincipal.activate();
            return false;
        }

        if(General.comparaPratoProduto(row.CDPRODINI, row.CDPRODFIN, getLocalVar('CDPICTPROD'))) {
            return true;
        } else {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL", {}, {
                type: 'INFORMATION'
            });
            widgetPrincipal.activate();
            return false;
        }
    }
    
    function validaDataInserida() {
        const widgetDatas = templateManager.container.getWidget('DATAS');
        const widgetDiasEntrega = templateManager.container.getWidget('diasEntrega');
        
        if(widgetDatas.dataSource.data.length > 0) {
            return true;
        } else {
            widgetDiasEntrega.activate();            
            MessageService.showMessageByCode("DATA_REQUIRED");
            return false;
        }
    }
    
    function montaListaProdutos(widget, row) {
        const widProdNovo = templateManager.container.getWidget("prodnovo");
        const widProd = templateManager.container.getWidget("produtosWidget");
        const widDiasEntrega = templateManager.container.getWidget("DATAS");
        const principalRow = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal').currentRow;
        
        return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/listaProdutos', 'Row', row).then(function(res) {
            let dados               = res;
            
            widProdNovo.isVisible   = true;
            widProd.isVisible       = false;
            widProdNovo.activate();

            if(dados.dataset.res[0].length <= 0) {
                MessageService.showMessageByCode("NO_DATA_SOL_CMP");
                widget.list();
    			widget.isVisible    = false;
    			ScreenService.openPopup(templateManager.container.getWidget('solicitacaoWidget'));
    			templateManager.container.getWidget('solicitacaoWidget').activate();
    			templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
                templateManager.container.getWidget("produtos").enabled               = true;
                templateManager.container.getWidget("justificativaAlteracao").enabled = true;
                templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
                templateManager.container.getWidget("dadosSolicitacao").activate();
            }
            
            const idSoliApro = getSolicitacaoAprovada(principalRow.IDSISDOS, principalRow.IDUTAPROVSOL, principalRow.IDPERALTSAPR[0]);
            
            days = [];
            var index = 0;
            dados.dataset.res[0].forEach(function(value) {
            	widDiasEntrega.dataSource.data.forEach(function(date) {
            		days.push(angular.copy(value)); 
            		
            		days[index].CDFILIAL = principalRow.CDFILIAL;
            		days[index].CDFILSOLI = principalRow.CDFILSOLI;
            		days[index].CDFILLANCA = principalRow.CDFILLANCA;
            		days[index].NRSOLICMP = principalRow.NRSOLICMP;
            		
            		days[index].DTPROGENTR = angular.copy(date.DTPROGENTR);
            		days[index].SEMANA = angular.copy(date.SEMANA);
            		days[index].IDSOLIAPROV = angular.copy(idSoliApro);
            		days[index].__isNew = angular.copy(true);
            		
            		days[index].QTSOLIPROD = 0;
            		days[index].QTVOLUITEMSO = angular.copy(date.QTVOLUITEMSO ? date.QTVOLUITEMSO : 0);
            		days[index].TXOBSITMSOL = angular.copy(!date.TXOBSITMSOL ? null : date.TXOBSITMSOL);
                    days[index].DTCMPANTERIOR = angular.copy(!date.DTCMPANTERIOR ? null : date.DTCMPANTERIOR);
                    days[index].DSJUSTOPER = angular.copy("");

            		index += 1;
            	});
            });
            
            widProdNovo.dataSource.data = days;
            
            widDiasEntrega.dataSource.data.map(rows => {
                delete rows.__rightActions;
                delete rows.__leftActions;
            });
            
        }).catch(function(error) {
            MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT', null, { type: 'ERROR' });
//             widget.list();
// 			   widget.isVisible = false;
// 			   ScreenService.openPopup(templateManager.container.getWidget("solicitacaoWidget"));
// 			   templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
//             templateManager.container.getWidget("produtosWidget").enabled         = true;
//             templateManager.container.getWidget("justificativaAlteracao").enabled = true;
//             templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
//             templateManager.container.getWidget("dadosSolicitacao").activate();
// 			   templateManager.container.getWidget("solicitacaoWidget").activate();
            widProdNovo.isVisible   = true;
            widProd.isVisible       = false;
            widProdNovo.activate();
            widProdNovo.dataSource.data = [];
        });
    }
    
    function insertSolicitaFinally() {
        const tabbedWidget = templateManager.container.getWidget('tabbedWidget');
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const dadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        const justificativaAlteracao = templateManager.container.getWidget("justificativaAlteracao");
        const inclusaoSolicitacao = templateManager.container.getWidget("inclusaoSolicitacao");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const widProdNovo = templateManager.container.getWidget("prodnovo");
        const inclusaoSolicitacaoPrincipal = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
        const widgetDatas = templateManager.container.getWidget('DATAS');
        const diasEntrega = templateManager.container.getWidget('diasEntrega');
        
        widProdNovo.isVisible = false;
        widProdNovo.enabled = false;
        produtosWidget.isVisible = true;
        produtosWidget.enabled = true;
        dadosSolicitacao.enabled = true;
        justificativaAlteracao.enabled = true;
        inclusaoSolicitacao.isVisible = false;
        
        tabbedWidget.defaultTab = "produtosWidget";
        ScreenService.closeSwipe();
        inclusaoSolicitacaoPrincipal.currentRow = {};
        diasEntrega.currentRow = {};
        widgetDatas.dataSource.data = [];
        solicitacaoWidget.reload();
        solicitacaoWidget.activate();
    }
    
    this.salvarDataProdNovo = function(widget) {
        if(widget.isValid()) {
            const widProdNovo = templateManager.container.getWidget('prodnovo');
            const inclusaoSolicitacao = templateManager.container.getWidget('inclusaoSolicitacaoPrincipal');
            const items = widProdNovo.dataSource.data;
            const principalRow = inclusaoSolicitacao.currentRow;
            
            ScreenService.confirmMessage('Itens com quantidades zero não serão inseridos.\nConfirma a operação??', 'question', function() {
                if(typeof widProdNovo.currentRow.__index == "number") {
                    General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProd','DataSet', [principalRow, items]).then(function(res) {
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
                        widProdNovo.dataSource.data[widProdNovo.currentRow.__index].__isNew = false;
                        MessageService.showMessageByCode("SUCCESS_OPERATION");
                        insertSolicitaFinally();
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                } else {
                    MessageService.showMessageByCode("ERRO_INDEX_PROD");
                }
            });
        }
    };
    
    function getSolicitacaoAprovada(idsisdos, idUtAprovSol, idPerAltSapr) {
        if (idsisdos == '3') {
            if (idUtAprovSol == 'S' && idPerAltSapr == 'S') {
                return 'N';
            }
            
            return 'S';
        } else {
            if (idUtAprovSol == 'S') {
                return 'N';
            }
            
            return 'S';
        }
    }
    
    this.cancelarProdNovo = function(args) {
        const activeWidget = templateManager.container.getActiveWidget();
        
        MessageService.confirmMessageByCode("CANCEL_INSERT_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
            insertSolicitaFinally();
        });
        
        /*var widgetPrincipal = templateManager.container.getWidget('principal');
        let row = widgetPrincipal.currentRow;
        row.EXCLUIR_SOLICITACAO = false;
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteSolicitacao','Row', row).then(function(success){
            var stripe                  = templateManager.container.getWidget("STRIPE");
            var widDatas                = templateManager.container.getWidget("DATAS");
            General.backOrCancel(args);
            templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
            templateManager.container.getWidget("produtos").enabled               = true;
            templateManager.container.getWidget("produtos").isVisible             = true;
            templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
            templateManager.container.getWidget("prodnovo").isVisible  = false;
            templateManager.container.getWidget("dadosSolicitacao").activate();
            if(!stripe.dataSource.data[0]){
                self.abreFiltro(false);
            }
            widDatas.dataSource.data = [];
            widDatas.getParent().currentRow = {};
            widgetPrincipal.currentRow = widgetPrincipal.backupRow;
            stripe.getAction("abreFiltro").isVisible                              = true;
            stripe.getAction("listaSoli").isVisible                               = true;
        });*/
    };
    
    this.cancelaSolicitacao = function(args) {
        const activeWidget = templateManager.container.getActiveWidget();
        
        if(activeWidget.name === "dadosSolicitacao") {
            activeWidget.template = "widget/form-view.html";
            activeWidget.reload();
            templateManager.container.getWidget("dadosSolicitacao").enabled = true;
            templateManager.container.getWidget("produtosWidget").enabled = true;
            if(activeWidget.currentRow.IDAUDALTSOL == "S")
                templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            else
                templateManager.container.getWidget("justificativaAlteracao").enabled = false;
            
            General.backOrCancel(args);
            //General.widgetCancelForm(activeWidget);
            activeWidget.list();
            activeWidget.reload();
        } else {
            MessageService.confirmMessageByCode("CANCEL_INSERT_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
                if(activeWidget.name === "inclusaoSolicitacaoPrincipal") {
                    General.widgetCancelForm(activeWidget);
                    insertSolicitaFinally();
                }
                
                if(activeWidget.name === "DATAS") {
                    insertSolicitaFinally();
                }
            }).catch(error => {
            });
        }
        
        /*const stripe                  = templateManager.container.getWidget("STRIPE");
        const filtroSolicitacao       = templateManager.container.getWidget("solicitacaoWidget");
        const widPrincipal            = templateManager.container.getWidget("principal");
        const widDatas                = templateManager.container.getWidget("DATAS");
        const widget = args.owner.widget;
        
        General.backOrCancel(args);
        
        widget.list();
        widget.reload();
        
        templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
        templateManager.container.getWidget("produtos").enabled               = true;
        templateManager.container.getWidget("justificativaAlteracao").enabled = true;
        templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
        templateManager.container.getWidget("dadosSolicitacao").activate();
        
        if(!stripe.dataSource.data[0]){
            self.abreFiltro(false);
        }
        
        widDatas.dataSource.data = [];
        widDatas.getParent().currentRow = {};
        
        stripe.getAction("abreFiltro").isVisible                              = true;
        stripe.getAction("listaSoli").isVisible                               = true;
        self.cancelaFiltro();*/
    };
    
    this.confirmsApproval = function() {
    	MessageService.confirmMessageByCode("CONFIRMS_APPROVAL", null, Constants.confirmationMessage).then(function(success) {
            const produtosWidget = templateManager.container.getWidget('produtosWidget');
    	    const checkedRows = produtosWidget.getCheckedRows();
    	    const disapprovedItems = checkedRows.filter(row => row.IDSOLIAPROV === 'N');
            
            if(disapprovedItems.length) {
                disapprovedItems.map(item => {
                    item.IDSOLIAPROV = 'S';
        			item.DTHRAPROVSOL = moment().format('DD/MM/YYYY HH:mm:ss');
        			item.CDOPERAPROV = getLocalVar('CDOPERADOR');
                });
                
        		General.callRestEngine('cmp#/crud/itemsoli/save', 'DataSet', checkedRows).then(function(success) {
        		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			produtosWidget.unSelectAll();
        			produtosWidget.reload();
                    setVisibleProductActionsAndFields();
        		}, function(err) {
        			setVisibleProductActionsAndFields();
        			ScreenService.showMessage(err.data.error);
        		});
            } else {
                produtosWidget.unSelectAll();
                setVisibleProductActionsAndFields();
            }
            
        });
	};
	
	this.confirmsDisapproval = function() {
	    MessageService.confirmMessageByCode("CONFIRMS_DISAPPROVAL", null, Constants.confirmationMessage).then(function(success) {
            const produtosWidget = templateManager.container.getWidget('produtosWidget');
    	    const checkedRows = produtosWidget.getCheckedRows();
    	    const approvedItems = checkedRows.filter(row => row.IDSOLIAPROV === 'S');
    	    
    	    if(approvedItems.length) {
                approvedItems.map(item => {
                    item.IDSOLIAPROV = 'N';
        			item.DTHRAPROVSOL = '';
        			item.CDOPERAPROV = '';
                });
                
        		General.callRestEngine('cmp#/crud/itemsoli/save', 'DataSet', checkedRows).then(function(success) {
        		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			produtosWidget.unSelectAll();
        			produtosWidget.reload();
    	            setVisibleProductActionsAndFields();
        		}, function(err) {
        		    setVisibleProductActionsAndFields();
        			ScreenService.showMessage(err.data.error);
        		});
    	    } else {
    	        setVisibleProductActionsAndFields();
    	        produtosWidget.unSelectAll();
    	    }
    	    
        });
	};
	
	this.produtosWidgetBeforeSelectRow = function(args){
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const solicitaRow = templateManager.container.getWidget('solicitacaoWidget').currentRow;
        
        if(permissionsArray.APROVAR_SOLICITACAO && solicitaRow.IDUTAPROVSOL === 'S') {
            produtosWidget.getAction('aprovaSolicitacao').isVisible = true;
            produtosWidget.getAction('reprovaSolicitacao').isVisible = true; 
	    } else {
	        produtosWidget.getAction('aprovaSolicitacao').isVisible = false;
            produtosWidget.getAction('reprovaSolicitacao').isVisible = false;   
	    }
    };
    
    this.produtosWidgetOnEnterOnce = function(args){
        const widget = args.owner;
        
        widget.beforeSelectAll = function(dataSet){
            const produtosFiltrados = dataSet.data.filter(row => row.IDSOLIAPROV == 'S');
            produtosFiltrados.map(row => { row.__notSelectable = true; });
        };
    };
    
    this.editaSolicitacao = function(widget) {
        widget.template = "widget/form.html";
        widget.edit();
        templateManager.container.getWidget("dadosSolicitacao").enabled = false;
        templateManager.container.getWidget("produtosWidget").enabled = false;
        templateManager.container.getWidget("justificativaAlteracao").enabled = false;
        widget.reload();
        
        if(widget.currentRow.IDULTDESTSOL == "S") {
            widget.getField("NMDESTSOLI").readOnly = false;
            widget.getField("NMDESTSOLI").reload();
        } else {
            widget.getField("NMDESTSOLI").readOnly = true;
            widget.currentRow.NMDESTSOLI = "";
            widget.currentRow.CDDESTSOLI = "";
            widget.getField("NMDESTSOLI").reload();
        }
    };
    
    this.controlaFieldDestSol = function(widget) {
        console.log(widget);
        widget.getField("NMDESTSOLI").clearValue();
        widget.getField("NMDESTSOLI").reload();
    };
    
    this.salvaSolicitacaoEditada = function(args) {
        const dadosSolicitacaoWidget = templateManager.container.getWidget("dadosSolicitacao");
        dadosSolicitacaoWidget.template = "widget/form-view.html";
        dadosSolicitacaoWidget.reload();
        const row = dadosSolicitacaoWidget.currentRow;
        const widget = args.owner.widget;
        console.log("Row Edit: ", row);
        delete row.__rightActions;
        delete row.__leftActions;
        row.__isNew = false;
        
        if(dadosSolicitacaoWidget.isValid()) {
            // return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvaSolicitacao', 'Row', row).then(function(success) {
            //     //templateManager.container.getWidget("dadosSolicitacao").enabled = true;
            //     //templateManager.container.getWidget("produtosWidget").enabled = true;
            //     //templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            //     //templateManager.container.getWidget("inclusaoSolicitacao").isVisible = false;
            //     //solicitacaoWidget.reload();
            //     //widget.list();
            //     General.backOrCancel(args);
            //     MessageService.successNotificationByCode('SUCCESS_OPERATION');
            // }, function(err) {
            //     ScreenService.showMessage(err.message);
            // });
            General.callRestEngine("cmp_solicitacao_solicitacaoCompras#/salvaSolicitacao", "Row", row).then(function(success) {
                templateManager.container.getWidget("dadosSolicitacao").enabled = true;
                templateManager.container.getWidget("produtosWidget").enabled = true;
                if(row.IDAUDALTSOL == "S")
                    templateManager.container.getWidget("justificativaAlteracao").enabled = true;
                else
                    templateManager.container.getWidget("justificativaAlteracao").enabled = false;
                General.backOrCancel(args);
                widget.list();
                widget.reload();
                MessageService.successNotificationByCode("SUCCESS_OPERATION");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
                templateManager.container.getWidget("dadosSolicitacao").enabled = true;
                templateManager.container.getWidget("produtosWidget").enabled = true;
                if(row.IDAUDALTSOL == "S")
                    templateManager.container.getWidget("justificativaAlteracao").enabled = true;
                else
                    templateManager.container.getWidget("justificativaAlteracao").enabled = false;
                General.backOrCancel(args);
                widget.list();
                widget.reload();
            });
            
        }
    };
    
    this.controlaFieldJustificativa = function(solExtraField, onEnter) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const justSolField = solExtraField.getParent().getField('DSJUSTSOL');
        
        if(solicitacaoWidget.currentRow.IDSOLEXTRA && onEnter) {
            solExtraField.checked = solicitacaoWidget.currentRow.IDSOLEXTRA === 'S';
        }
        
        if(solExtraField.checked && solicitacaoWidget.currentRow.IDJUSSOLEXT === 'S') {
            justSolField.readOnly = false;
            justSolField.validations = { "required": true };
        } else {
            justSolField.readOnly = true;
            delete justSolField.validations;
        }
        
        if(!onEnter && solicitacaoWidget.currentRow.IDJUSSOLEXT === 'S') {
            justSolField.setValue();
        }
    };
    
    function existsPermissionsDeleteSolicita() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        if(verifyOperatorPermission(solicitacaoWidget.currentRow) && verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_SOLICITACAO')) {
            if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
                return produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length === 0;
            }
            
            return true;
        }
        
        return false;
    }
    
    this.deleteSolicita = function(widget){
	    const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const currentRow = solicitacaoWidget.currentRow;
	    
	    if(existsPermissionsDeleteSolicita()) {
    	    MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
    	        delete currentRow.__leftActions;
                delete currentRow.__rightActions;
    	        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteSolicitacao','Row', currentRow).then(function(success){
                    MessageService.successNotificationByCode('SUCCESS_OPERATION');
        			solicitacaoWidget.reload();
        			if(widget !== solicitacaoWidget){
        			    ScreenService.closeSwipe();
        			    solicitacaoWidget.activate();
        			}
                }, function(err) {
        			ScreenService.showMessage(err.data.error);
        		});
            });
	    } else {
	        MessageService.showMessageByCode('WITHOUT_PERMISSION', null, Constants.errorMessage);
	    }
    };
    
    this.confirmsApprovalSolicita = function() {
	    const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
	    const currentRow = solicitacaoWidget.currentRow;
    	    
        MessageService.confirmMessageByCode("CONFIRMS_APPROV_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/aprovarSolicitacoes','Row', currentRow).then(function(success){
    			ScreenService.closePopup();
    		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
    			produtosWidget.reload().then(function(){
    		        setVisibleProductActionsAndFields();
    			});
    		}, function(err) {
    		    ScreenService.closePopup();
    			ScreenService.showMessage(err.data.error);
    		});
        });
	};
	
	this.confirmsDisapprovalSolicita = function() {
	    const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
	    const produtosWidget = templateManager.container.getWidget('produtosWidget');
	    const currentRow = solicitacaoWidget.currentRow;
    	    
        MessageService.confirmMessageByCode("CONFIRMS_DISAPPROV_SOLICITA", null, Constants.confirmationMessage).then(function(success) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/reprovaSolicitacoes','Row', currentRow).then(function(success){
    		    ScreenService.closePopup();
    		    MessageService.successNotificationByCode('SUCCESS_OPERATION');
    			produtosWidget.reload().then(function(){
    		        setVisibleProductActionsAndFields();
    			});
    		}, function(err) {
    			setVisibleProductActionsAndFields();
    			ScreenService.showMessage(err.data.error);
    		});
    		
        });
	};
	
	this.produtosReload = function() {
        var footerstripe = templateManager.container.getWidget("footerProdStripe");
        var widget = templateManager.container.getWidget("produtosWidget");
        var widSolicitacao = templateManager.container.getWidget("solicitacaoWidget");
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectProdutosGrid','Row', widSolicitacao.currentRow).then(function(callback){
            var produtos = callback.dataset.produtos;
            widget.dataSource.data = produtos;
            footerstripe.currentRow.TOTALPROD = produtos.length;
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.adicionaProduto = function() {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        adicionaProduto.currentRow.CDPRODUTO = "";
        adicionaProduto.currentRow.NMPRODUTO = "";
        adicionaProduto.backupRow = angular.copy(adicionaProduto.currentRow);
        setDataFieldReadOnly(adicionaProduto, true);
        
        adicionaProduto.getField('NMPRODUTO').dataSourceFilter = [
			{
				'name': 'P_CDFILIAL',
				'operator': '=',
				'value': solicitacaoWidget.currentRow.CDFILSOLI
			},
			{
				'name': 'P_PRODCOMPRA',
				'operator': '=',
				'value': solicitacaoWidget.currentRow.IDUTPRODPREF
			},
			{
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		ScreenService.openSwipe(adicionaProduto);
    };
    
    this.cancelaAddProduto = function(args) {
        const adicionaProduto = templateManager.container.getWidget('adicionaProduto');
        const datasAddProduto = templateManager.container.getWidget('datasAddProduto');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        ScreenService.closeSwipe().then(function(){
            adicionaProduto.currentRow = adicionaProduto.backupRow;
            datasAddProduto.dataSource.data = [];
            produtosWidget.activate();
        });
    };
    
    this.salvaAddProduto = function(validacaoRealizada) {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        const datasAddProduto = templateManager.container.getWidget('datasAddProduto');
        
        if(adicionaProduto.isValid()) {
            if(datasAddProduto.dataSource.data.length > 0){
                if(verifyAlreadyApprovedItems(produtosWidget.dataSource.data)) {
                    verifyItemsWithoutQTSOLIPROD(datasAddProduto.dataSource.data).then(function(){
                        if(validaUtilizaAuditoriaAletarcaoAF(validacaoRealizada, 'cmp03100_lancamento_de_solicitacao_de_comprasController.salvaAddProduto(true)')) {
                            this.salvaProduto(produtosWidget);
                        }
                    }.bind(this));
                }
            } else {
                MessageService.showMessageByCode('DATE_IS_NECESSARY', null, Constants.errorMessage);
            }
        }
    };
    
    function verifyAlreadyApprovedItems(data) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(data.filter(value => value.IDSOLIAPROV === 'S').length > 0 && solicitacaoWidget.currentRow.IDUTAPROVSOL == 'S' && solicitacaoWidget.currentRow.IDIMPINCSOLAPR == 'S'){
            MessageService.showMessageByCode('SOLICITA_ALREADY_APPROVED_ITEMS', null, Constants.errorMessage);
            return false;
        }
        
        return true;
    }
    
    function verifyItemsWithoutQTSOLIPROD(data) {
        const deferred = ZHPromise.defer();
        
        if(data.filter(value => value.QTSOLIPROD_inline).length === 0) {
            return MessageService.confirmMessageByCode("INSERT_ITEMSOLI_ZERO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    function validaUtilizaAuditoriaAletarcaoAF(validacaoRealizada, nomeFuncao) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
        
        if(!validacaoRealizada && solicitacaoWidget.currentRow.IDAUDALTSOL == 'S') {
            justificativaAlteracao.getAction('salvar').events[0].code = "args.owner.widget.isValid() ? " + nomeFuncao + " : false";
            justificativaAlteracao.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
            justificativaAlteracao.applyDefaultValue();
            
            ScreenService.openPopup(justificativaAlteracao);
            
            return false;
        }
        
        return true;
    }
    
    this.salvaProduto = function(produtosWidget) {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        let produtoNasceAprovado;
        
        if (solicitacaoWidget.currentRow.IDUTAPROVSOL == 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[0] == 'S') {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/existeProdutosAprovados','Row', solicitacaoWidget.currentRow).then(function(response) {
                if (response.dataset.data.EXISTE_PRODUTOS_APROVADOS) {
                    produtoNasceAprovado = 'S';
                } else {
                    produtoNasceAprovado = 'N';
                }
                
                continuaSalvaProduto(produtoNasceAprovado);
            }).catch(function(response) {
                ScreenService.showMessage(response.error);
            });
        } else {
            produtoNasceAprovado = solicitacaoWidget.currentRow.IDUTAPROVSOL === 'N' ? 'S' : 'N';
            continuaSalvaProduto(produtoNasceAprovado);
        }
    };
    
    function continuaSalvaProduto(idSoliAprov) {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const dataGrid = templateManager.container.getWidget('datasAddProduto');
        const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        const dataSet = dataGrid.dataSource.data.map(value => {
            value.CDFILIAL      = solicitacaoWidget.currentRow.CDFILSOLI;
            value.CDFILSOLI     = solicitacaoWidget.currentRow.CDFILSOLI;
            value.NRSOLICMP     = solicitacaoWidget.currentRow.NRSOLICMP;
            value.CDPRODUTO     = adicionaProduto.currentRow.CDPRODUTO;
            value.CDFILLANCA    = solicitacaoWidget.currentRow.CDFILLANCA;
            value.__isNew       = true;
            value.CDOPERLANC    = solicitacaoWidget.currentRow.CDOPERLANC;
            value.CDOPERADOR    = solicitacaoWidget.currentRow.CDOPERADOR;
            //value.TXOBSITMSOL   = !dataGrid.dataSource.data[i].TXOBSITMSOL ? null : dataGrid.dataSource.data[i].TXOBSITMSOL;
            //value.DTCMPANTERIOR = !dataGrid.dataSource.data[i].DTCMPANTERIOR ? null : dataGrid.dataSource.data[i].DTCMPANTERIOR;
            value.IDSOLIAPROV   = idSoliAprov;
            value.DSJUSTOPER    = justificativaAlteracao.currentRow.DSJUSTOPER ? justificativaAlteracao.currentRow.DSJUSTOPER : "";
            //value.QTVOLUITEMSO  = !dataGrid.dataSource.data[i].QTVOLUITEMSO ? 0 : dataGrid.dataSource.data[i].QTVOLUITEMSO;
            return value;
            
        });
        
        const datas = dataSet.filter(value => value.QTSOLIPROD);
        
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(() => {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProdNovo','Row', datas).then(function() {
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                adicionaProduto.currentRow = adicionaProduto.backupRow;
                dataGrid.dataSource.data = [];
                produtosWidget.activate();
                produtosWidget.reload().then(function(data) {
    			    setProdStripeFooter(data);
    			});
                MessageService.successNotificationByCode('SUCCESS_OPERATION');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    }
    
    function verifyExistsProductAndDate() {
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        const adicionaProduto = templateManager.container.getWidget('adicionaProduto');

        return produtosWidget.dataSource.data.filter(value => value.CDPRODUTO === adicionaProduto.currentRow.CDPRODUTO && moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    function verifyExistsDate() {
        const adicionaProduto = templateManager.container.getWidget('adicionaProduto');
        const datasAddProduto = templateManager.container.getWidget("datasAddProduto");
        
        return datasAddProduto.dataSource.data.filter(value => moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    this.adicionaDataProd = function() {
        const datasAddProduto = templateManager.container.getWidget("datasAddProduto");
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const dadosSolicitacaoWidget = templateManager.container.getWidget("dadosSolicitacao");
        const selectedDate = adicionaProduto.currentRow.DTPROGENTR;
        const row = {
            "CDFILSOLI": dadosSolicitacaoWidget.currentRow.CDFILSOLI
        };
        
        if(adicionaProduto.currentRow && adicionaProduto.currentRow.DTPROGENTR) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaDataProcessamento', 'Row', row).then(function(res) {
                const dado = res.dataset.res[0][0].DTPROCESSA;
                const dataProcessamento = moment(dado, "DD/MM/YYYY").format("DD/MM/YYYY");
                if(adicionaProduto.currentRow.DTPROGENTR >= dataProcessamento) {
                    const numDayWeek = moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").weekday();
                    const daysOfWeek = ["WEEK_SUNDAY", "WEEK_MONDAY", "WEEK_TUESDAY", "WEEK_WEDNESDAY", "WEEK_THURSDAY", "WEEK_FRIDAY", "WEEK_SATURDAY"];
            
                    MessageService.getMessageByCode(daysOfWeek[numDayWeek]).then( dayofWeek => {
                        if(verifyExistsProductAndDate()) {
                            if(verifyExistsDate()) {
                                datasAddProduto.dataSource.data.push({
                                    "DTPROGENTR": adicionaProduto.currentRow.DTPROGENTR,
                                    "SEMANA": dayofWeek,
                                    "TXOBSITMSOL": null,
                                    "DTCMPANTERIOR": null,
                                    "QTVOLUITEMSO": 0
                                });
                                datasAddProduto.getAction('CALCULO_MEDIA').isVisible = true;
                            } else {
                                MessageService.showMessageByCode('DATE_ALREADY_INFORMED', null, Constants.errorMessage);
                            }
                        } else {
                            MessageService.showMessageByCode('EXISTS_PRODUCT_DATE', null, Constants.errorMessage);
                        }
                    
                        datasAddProduto.reload();
                    
                        if(selectedDate) {
                            adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                            adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                            adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                        }
                    });
                } else {
                    MessageService.showMessageByCode("DTPROGENTR_MAIOR_DTPROCESSA", { "DATA": dataProcessamento });
                    adicionaProduto.getField("DTPROGENTR").value(dataProcessamento);
                    adicionaProduto.getField("DTPROGENTR").currentDate = dataProcessamento;
                    adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                }
            }).catch(function(error) {
                console.log(error);
            });
        } else {
            MessageService.showMessageByCode("INVALID_DATA");
            return false;
        }
    };
    
    function verificaDataExistente(data, widgetDestino) {
        const widgetDestinoDataSource = widgetDestino.dataSource.data;

        if (!Util.isEmptyOrBlank(widgetDestinoDataSource)) {
            return widgetDestinoDataSource.filter(dataDestino => dataDestino.DTPROGENTR == data).length <= 0;
        }
        
        return true;
    }
    
    this.adicionaData = function(widget) {
        const widDatas = templateManager.container.getWidget("DATAS");
        const inclSolWidget = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        if(inclSolWidget.currentRow.CDFILSOLI) {
            if(widget.currentRow && widget.currentRow.DTPROGENTR) {
                General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaDataProcessamento', 'Row', inclSolWidget.currentRow).then(function(res) {
                    const dado = res.dataset.res[0][0].DTPROCESSA;
                    const dataProcessamento = moment(dado, "DD/MM/YYYY").format("DD/MM/YYYY");
                    if(widget.currentRow.DTPROGENTR >= dataProcessamento) {
                        var dias      = ["Domingo", "Segunda-feira","Terça-feira","Quarta-feira","Quinta-feira","Sexta-feira","Sábado"];
                        var dayOfWeek = moment(widget.currentRow.DTPROGENTR, "DD/MM/YYYY").weekday();
                        
                        if (verificaDataExistente(widget.currentRow.DTPROGENTR, widDatas)) {
                            widDatas.dataSource.data.push({
                                "DTPROGENTR": widget.currentRow.DTPROGENTR,
                                "SEMANA": dias[dayOfWeek]
                            });
                        } else {
                            MessageService.showMessageByCode("DATA_EXISTS");
                        }
                        widDatas.reload();
                        var diaExistente = widget.widgets[0].dataSource.data.slice(-1)[0].DTPROGENTR;
                        widget.getField("DTPROGENTR").value(moment(diaExistente, "DD/MM/YYYY").add(1, 'days'));
                        
                        widget.getField("DTPROGENTR").currentDate = moment(diaExistente, "DD/MM/YYYY").add(1, 'days');
                            
                        widget.fields[0].element[0].value = widget.currentRow.DTPROGENTR ;
                    } else {
                        MessageService.showMessageByCode("DTPROGENTR_MAIOR_DTPROCESSA", { "DATA": dataProcessamento });
                        
                        widget.getField("DTPROGENTR").value(dataProcessamento);
                        widget.getField("DTPROGENTR").currentDate = dataProcessamento;
                        widget.fields[0].element[0].value = widget.currentRow.DTPROGENTR ;
                        return false;
                    }
                }).catch(function(error) {
                    console.log(error);
                });
                
            } else {
                MessageService.showMessageByCode("INVALID_DATA");
                return false;
            }
        } else {
            MessageService.showMessageByCode("EMPTY_CDFILSOLI");
            return false;
        }
    };
    
    this.openTelaAlteracaoAutom = function() {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#/cmp06900_alteracao_automatica_solicitacao_compras').then(function() {
            const widAlteracao = templateManager.container.getWidget('cmp06900_alteracao_automatica_solicitacao_compras_grid');
        	const filterRow = {
                    "DTSOLICITACAO" : solicitacaoWidget.currentRow.DTSOLCMP,
                    "NMFILIAL" : [solicitacaoWidget.currentRow.CDFILSOLI],
                    "NRSOLI" : [solicitacaoWidget.currentRow.NRSOLICMP],
                    'ENTREGA': ['ED', 'OL']
        	};
            
            widAlteracao.ABERTA_POR = 'Lançamento da Solicitação de Compras';
            
            Utilities.startFilter(widAlteracao, filterRow).then(function() {
            	widAlteracao.getField('NMFILIAL').reload();
            	widAlteracao.getField('NRSOLI').reload();
            });
        });
    };
    
    this.calcularMediaInclusao = function(widget) {
        var total  = 0;
        var fields = widget.getCheckedRows();
        for(var i  = 0; i<fields.length; i++){
        	total  = parseFloat(total) + parseFloat(fields[i].QTSOLIPROD);	
        }
        var result = parseFloat(total) / parseFloat(i);
        MessageService.showMessageByCode("AVERAGE", { "PARAM": result });
    };
    
    this.calcularMedia = function(widget) {
        const adicionaProduto = templateManager.container.getWidget("adicionaProduto");
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(adicionaProduto.currentRow.CDPRODUTO) {
            if(widget.dataSource.data.length) {
                widget.currentRow.CDFILSOLI = solicitacaoWidget.currentRow.CDFILSOLI;
                widget.currentRow.CDPRODUTO = adicionaProduto.currentRow.CDPRODUTO;
            
                General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectCalculaMedia','Row', widget.currentRow).then(function(callback){
                    const media = callback.dataset.media;
                    
                    if(media.length === 0) {
                        MessageService.showMessageByCode("NO_AVERAGE");
                    } else {
                        widget.dataSource.data.map(value => {
                            value.QTSOLIPROD_inline = media[0].QTMEDSOLPROD;
                            value.QTSOLIPROD= media[0].QTMEDSOLPROD;
                            value.changed_QTSOLIPROD = media[0].QTMEDSOLPROD;
                            value.changed = true;     
                        });
                        MessageService.showMessageByCode("AVERAGE_SUCCESS");
                        widget.inlineEdit();
                        widget.lastInlineEditingElement = $("#masonry-item-" + widget.id);
                    }
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }
        } else {
            MessageService.showMessageByCode('PRODUCT_IS_REQUIRED', null, Constants.errorMessage);
        }
    };
    
    this.cancelaEditProdutos = function(widget) {
        cancelEditProducts(widget);
    };
    
    function cancelEditProducts(widget) {
        widget.rollbackInlineEdit();
        widget.list();   
    }
    
    function verifyItemWithoutQTSOLIPROD(row) {
        const deferred = ZHPromise.defer();
        
        if(row.QTSOLIPROD_inline === 0) {
            return MessageService.confirmMessageByCode("INSERT_ITEMSOLI_ZERO", null, Constants.confirmationMessage);
        } else {
            deferred.resolve();
        }
        
        return deferred.promise;
    }
    
    /*function verifyIncreaseProducts(qtSoliProd, qtOriginal, row) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(qtSoliProd > qtOriginal){ 
            if(verifyPermission(solicitacaoWidget.currentRow, 'AUMENTAR_QUANTIDADE')) {
                if(permissionsArray.percentAumentar !== null){
                    if(qtSoliProd > parseFloat(qtOriginal + (qtOriginal * (permissionsArray.percentAumentar/100)))){
                        MessageService.showMessageByCode('QTSOLIPROD_CANNOT_BE_CHANGED', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                            return false;  
                        });
                    }
                }
            } else {
                MessageService.showMessageByCode('WITHOUT_PERMISSION', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                    return false;
                });
            }
        }
        
        return true;
    }
    
    function verifyDecreaseProducts(qtSoliProd, qtOriginal, row) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(qtSoliProd < qtOriginal){
            if(verifyPermission(solicitacaoWidget.currentRow, 'DIMINUIR_QUANTIDADE')) {
                if(permissionsArray.percentDiminuir !== null){
                    if(qtSoliProd < parseFloat(qtOriginal - (qtOriginal * (permissionsArray.percentDiminuir/100)))){
                        MessageService.showMessageByCode('QTSOLIPROD_CANNOT_BE_CHANGED', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                            return false;  
                        });
                    }
                }
            } else {
                MessageService.showMessageByCode('WITHOUT_PERMISSION', {QTSOLIPROD: row.QTSOLIPROD}, Constants.errorMessage).then(function(){
                    return false;
                });    
            }
        }
        
        return true;
    }*/
    
    function saveEditProducts(widget) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
        const filterdRows = widget.dataSource.data.filter(row => row.changed === true);
        const dataRow = filterdRows.map(value => {
            value.CDFILLANCA = value.CDFILLAN;
            value.DSJUSTOPER = justificativaAlteracao.currentRow.DSJUSTOPER ? justificativaAlteracao.currentRow.DSJUSTOPER : "";
            
            if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[2] === 'S'){
                value.IDSOLIAPROV = 'N';
            } else if (solicitacaoWidget.currentRow.IDUTAPROVSOL === 'N'){
                value.IDSOLIAPROV = 'S';
            }
            
            return value;
        });
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarQuantidadeProd','Row', dataRow).then(function(success) {
            if(success.messages[0].message.length) {
                showlogEditProducts(widget, success.messages[0].message);
            } else {
                ScreenService.closePopup();
                widget.commitInlineEdit();
                widget.list();
                widget.reload().then(function(callback){
					if(callback.dataset.itens_solicitacao.length === 0){
						ScreenService.closeSwipe();
						solicitacaoWidget.reload();
						solicitacaoWidget.activate();
					}	
				});
            }
        }, function(err) {
            ScreenService.closePopup();
            cancelEditProducts(widget);
            ScreenService.showMessage(err.data.error);
        });
    }
    
    function showlogEditProducts(widget, success) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        let messages = [];
        
    	messages.push(MessageService.getMessageByCode("WITHOUT_SELECTED_ITEMS"));
    	messages.push(MessageService.getMessageByCode("WITHOUT_PERMISSION"));
    	messages.push(MessageService.getMessageByCode("QTSOLIPROD_CANNOT_BE_CHANGED"));
    	
    	Promise.all(messages).then((messages) => {
            let arrayMesssages = [];
            let arrayError = [];
            	
            if(messages[0]) arrayMesssages.WITHOUT_SELECTED_ITEMS = messages[0];
            if(messages[1]) arrayMesssages.WITHOUT_PERMISSION = messages[1]; 
            if(messages[2]) arrayMesssages.QTSOLIPROD_CANNOT_BE_CHANGED = messages[2];

            success.forEach(function(row) {
            	if (!Util.isEmptyOrBlank(row.MESSAGE)) {
				    arrayError = arrayError.concat(setArrayLog(row, arrayMesssages));
				}
            });
            
            ScreenService.closePopup();
            cancelEditProducts(widget);
            widget.reload();

            General.showErrorMessages(widgetOrigem, arrayError, ScreenService.i18n('Log'));
    	});
    }
    
    function setArrayLog(messages, arrayMesssages) {
        let result = [];
        
        result.push(arrayMesssages[messages.MESSAGE].replace('__NMPRODUTO__', messages.NMPRODUTO).replace('__QTSOLIPROD__', messages.QTSOLIPROD));		
		
		return result;
    }

    function verifyAlreadyApprovedEditadedItem(widget) {
        const solicitacaoWidget = templateManager.container.getWidget("solicitacaoWidget");
        
        if(solicitacaoWidget.currentRow.IDUTAPROVSOL == 'S' && solicitacaoWidget.currentRow.IDPERALTSAPR[1] == 'N' && widget.currentRow.IDSOLIAPROV == 'S') {
            MessageService.showMessageByCode('QTSOLIPROD_LIBERADA_COMPRA', null, Constants.errorMessage);
            cancelEditProducts(widget);
            return false;
        }

        return true;
    }
    
    this.salvaEditProdutos = function(validacaoRealizada) {
        const produtosWidget = templateManager.container.getWidget("produtosWidget");
        
        if(produtosWidget.isValid()) {
            if(verifyAlreadyApprovedEditadedItem(produtosWidget)) {
                verifyItemWithoutQTSOLIPROD(produtosWidget.currentRow).then(function(){
                    if(validaUtilizaAuditoriaAletarcaoAF(validacaoRealizada, 'cmp03100_lancamento_de_solicitacao_de_comprasController.salvaEditProdutos(true)')) {
                        saveEditProducts(produtosWidget);
                    }
                }.bind(this));
            }
        }
    };
    
    function existsPermissionsDeleteItems() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const produtosWidget = templateManager.container.getWidget('produtosWidget');

        if(verifyOperatorPermission(solicitacaoWidget.currentRow) && verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_DTENTREGA') && verifyPermission(solicitacaoWidget.currentRow, 'EXCLUIR_PRODUTO')) {
            if(solicitacaoWidget.currentRow.IDUTAPROVSOL === 'S') {
                return produtosWidget.dataSource.data.filter(value => value.IDSOLIAPROV === 'S').length === 0;
            }
            
            return true;
        }
        
        return false;
    }
    
    this.excluiDataProduto = function(validacaoRealizada) {
        if(existsPermissionsDeleteItems()) {
    	    MessageService.confirmMessageByCode("CONFIRM_DELETE", null, Constants.confirmationMessage).then(function(success) {
    	        const produtosWidget = templateManager.container.getWidget("produtosWidget");
                const justificativaAlteracao = templateManager.container.getWidget("popupJustificativaAlteracao");
    	        const checkedRows = produtosWidget.getCheckedRows();
    	        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
    	        const disapprovedItems = checkedRows.filter(row => row.IDSOLIAPROV === 'N');
    	        const idUtAprovSol = solicitacaoWidget.currentRow.IDUTAPROVSOL;
                
                if(idUtAprovSol === 'N' || (idUtAprovSol === 'S' && disapprovedItems.length)) {
                    if(validaUtilizaAuditoriaAletarcaoAF(validacaoRealizada, 'cmp03100_lancamento_de_solicitacao_de_comprasController.excluiDataProduto(true)')) {
                        const dataRow = produtosWidget.dataSource.checkedRows.map(value => {
                            value.CDFILLANCA = value.CDFILLAN;
                            value.CDOPERADOR = getLocalVar('CDOPERADOR');
                            value.DSJUSTOPER = justificativaAlteracao.currentRow.DSJUSTOPER ? justificativaAlteracao.currentRow.DSJUSTOPER : "";
                            
                            return value;
                        });
                        
                        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteQuantidadeProd', 'Row', dataRow).then(function(success) {
                            MessageService.successNotificationByCode('SUCCESS_OPERATION');
                            ScreenService.closePopup();
                            produtosWidget.unSelectAll();
                            produtosWidget.list();
                            produtosWidget.reload().then(function(callback){
                                if(callback.dataset.itens_solicitacao.length === 0){
                                    ScreenService.closeSwipe();
									solicitacaoWidget.reload();
									solicitacaoWidget.activate();
								}	
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                }
            });
	    } else {
	        MessageService.showMessageByCode('WITHOUT_PERMISSION', null, Constants.errorMessage);
	    }
    };
    
    function setDataFieldReadOnly(widget, isReadOnly) {
        widget.getField('DTPROGENTR').readOnly = isReadOnly;
        widget.getField('ADD_DATA').isVisible = !isReadOnly;
        
        templateManager.updateTemplate();
    }
    
    /*até aqui*/
    
    self.setFooterTotal = function(){
        var widget = templateManager.container.getWidget('STRIPEFOOTER');
        var detalhesProduto = templateManager.container.getWidget('detalhesProduto');
        var totalqtd = 0;
        var totalvalor = 0;
        for(var i = 0; i < detalhesProduto.dataSource.data.length; i++){
            totalqtd+= parseFloat(detalhesProduto.dataSource.data[i].QTSOLIPROD); 
            totalvalor+= parseFloat(detalhesProduto.dataSource.data[i].VRTOTAL); 
        }
      var mask = {
            type: "float",
            params: {
                symbol: "",
                allowNegative: false,
                precision: 3,
                thousands: ".",
                decimal: ","
            }
      };
        var maskValor = {
            type: "currency",
            params: {
                symbol: "",
                precision: 2,
                thousands: ".",
                decimal: ","
            }
        };
        widget.currentRow.TOTALIZADOR = Util.applyMask(totalqtd, mask, maskEngine, ZhUtil);
        widget.currentRow.QTDTOTAL = Util.applyMask(totalvalor, maskValor, maskEngine, ZhUtil);
        widget.reload();
        
    };
    
    this.verificaProdutoAprovado = function(args) {
        const widStripe = templateManager.container.getWidget("STRIPE");
        const widgetProduto = templateManager.container.getWidget('produtos');
        const isTrue = (widStripe.currentRow.IDTIPLAN == 'A' && widStripe.dataSource.data[0].IDPERALTSAPR[1] == 'N') || (widStripe.dataSource.data[0].IDUTAPROVSOL == 'S' && widgetProduto.dataSource.data[0].IDSOLIAPROV == 'S');
        
        if(isTrue) {
            MessageService.showMessageByCode("QTSOLIPROD_LIBERADA_COMPRA");
            args.e.preventDefault();
        }   
    };
    
    this.widgetProdutoOnEnterOnceEventOnSelectedAll = function(args) {
        let widget = templateManager.container.getWidget("detalhesProduto");
        widget.beforeSelectAll = function(dados) {
            let produtosFiltrados = dados.data.filter(row => row.IDSOLIAPROV == 'S');
            produtosFiltrados.forEach(row => { row.__notSelectable = true; });
        };
    };
    
    /*detalhes*/
    

    function getAprovacaoSolicitacao(item) {
        if (item.IDSOLIAPROV == 'N' && !utilizaAprovacaoSolicitacaoCompras()) {
            return 'S';
        }
        
        return item.IDSOLIAPROV;
    }
    
    function getAprovacaoSolicitacaoGR(item, parameters) {
        if (parameters.IDUTAPROVSOL == 'S' && parameters.IDPERALTSAPR[0] == 'S') {
                return 'N';
            }
        
        return 'S';
    }
    
    function utilizaAprovacaoSolicitacaoCompras() {
        const paramUtilizaAprovacaoSolicitacaoCompras = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal").currentRow.IDUTAPROVSOL;
        
        return paramUtilizaAprovacaoSolicitacaoCompras == 'S';
    }
    
    this.widgetOnEnterOnceDadosSolicitacao = function() {
        const widgetDadosSolicitacao = templateManager.container.getWidget("dadosSolicitacao");
        
        if(Util.isEmptyOrBlank(widgetDadosSolicitacao.externalRow)) {
            let filtroWidget = templateManager.container.getWidget("filtroWidget");
            
            filtroWidget.currentRow.NMFILIAL = getLocalVar('NMFILIAL');
            filtroWidget.currentRow.CDFILIAL = getLocalVar('CDFILIAL');
            filtroWidget.getField('NMTIPOCUSTO').readOnly = false;
            
            self.validaGerente(filtroWidget);
            self.validaTipoCusto(filtroWidget);
            //self.validaUnidade(filtroWidget);
            
            General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
                setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
                setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP);
            }, function(error) {
    			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
    		});
        
            self.abreFiltro(false);
        } else {
            const widgetSolicitacao = templateManager.container.getWidget("solicitacaoWidget");
            self.confirmaFiltroSolicitacao(widgetSolicitacao);
        }
    };
    
    /*self.validaUnidade = function(filtroWidget) {
        if(filtroWidget.currentRow.CDFILIAL) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaFilialSolicitacao','Row', [filtroWidget.currentRow.CDFILIAL]).then(function(res){
                let dataResponse = res.dataset.res;
                
                filtroWidget.dataSource.data = dataResponse;
                
                if(dataResponse[1].IDULTDESTSOL != 'N'){
                    filtroWidget.getField('COMPRADOR').isVisible = true;
                } else {
                    filtroWidget.getField('COMPRADOR').isVisible = false;
                }
                
                if(dataResponse[1].IDULTCOMPSOL != 'N'){
                    filtroWidget.getField('NMDESTSOLI').isVisible = true;
                } else {
                    filtroWidget.getField('NMDESTSOLI').isVisible = false;
                }
            }).catch(function(erro) {
                if(erro.errorCode === 100) {
                    ScreenService.showMessage(erro.error);
                    filtroWidget.getField('NMDESTSOLI').isVisible = false;
                    filtroWidget.getField('COMPRADOR').isVisible = false;
                } else {
                    ScreenService.showMessage(erro);
                }
            });
        }
    };*/
    
    self.validaGerente = function(filtroWidget) {
        return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaGerente','Row', [getLocalVar('CDOPERADOR'), getLocalVar('NRORG')]).then(function(ger){
            
            var dataGerente = ger.dataset;
            
            if(dataGerente.ger[0] == 0){
                filtroWidget.getField('NMOPERADOR').isVisible   = false;
                filtroWidget.getField('APROVACAO').isVisible    = false;
                
            }else if(dataGerente.ger[0] != 0 && dataGerente.ger[1] == 0){
                filtroWidget.getField('NMOPERADOR').isVisible   = true;
                
            }else if(dataGerente.ger[0] != 0 && dataGerente.ger[1] != 0){
                filtroWidget.getField('NMOPERADOR').isVisible   = true;
                filtroWidget.getField('APROVACAO').isVisible    = true;
            }
        
        });
    };
    
    this.confirmaFiltroFilial = function(widget) {
        var widSolicitacao = templateManager.container.getWidget("solicitacaoWidget");
                
        return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectSoliciFilial','Row', widget.currentRow).then(function(res){
            var dados = res;
            widSolicitacao.dataSource.data = dados.dataset.res[0];
            
        });
    };
    
    
    this.carregaDataSource = function(widget) {
        
        var filtroWidget        = templateManager.container.getWidget('filtroWidget');
        filtroWidget.currentRow.CDFILIAL = filtroWidget.currentRow.CDFILIAL ? filtroWidget.currentRow.CDFILIAL : templateManager.container.getWidget('dadosSolicitacao').currentRow.CDFILSOLI;
        
        widget.dataSourceFilter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": filtroWidget.currentRow.CDFILIAL
            },
            {
                "name": "P_DTSOLINI",
                "operator": "=",
                "value": filtroWidget.currentRow.DTSOLINI
            },
            {
                "name": "P_DTSOLFIM",
                "operator": "=",
                "value": filtroWidget.currentRow.DTSOLFIM
            },
            {
                "name": "P_TSOLICITA",
                "operator": "=",
                "value": filtroWidget.currentRow.TSOLICITA
            },
            {
                "name": "P_COMPRADOR",
                "operator": "=",
                "value": !Util.isEmptyOrBlank(filtroWidget.currentRow.COMPRADOR) ? filtroWidget.currentRow.COMPRADOR.join('_') : ""
            },
            {
                "name": "P_TCOMPRADOR",
                "operator": "=",
                "value": !Util.isEmptyOrBlank(filtroWidget.currentRow.COMPRADOR) ? "" : 'T'  
            },
            {
                "name": "P_DESTINO",
                "operator": "=",
                "value": filtroWidget.currentRow.CDDESTSOLI
            },
            {
                "name": "P_TDESTINO",
                "operator": "=",
                "value": filtroWidget.currentRow.TCDDESTSOLI
            },
            {
                "name": "P_TCDGERENTE",
                "operator": "=",
                "value": filtroWidget.currentRow.TCDGERENTE
            },
            {
                "name": "P_CDGERENTE",
                "operator": "=",
                "value": filtroWidget.currentRow.CDGERENTE
            },
            {
                "name": "P_STATUS",
                "operator": "=",
                "value": !Util.isEmptyOrBlank(filtroWidget.currentRow.APROVACAO) ? filtroWidget.currentRow.APROVACAO.join('_') : "T"
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": filtroWidget.currentRow.CDOPERADOR
            },
            {
                "name": "P_TENTREGA",
                "operator": "=",
                "value": filtroWidget.currentRow.TENTREGA
            },
            {
                "name": "P_ENTRINI",
                "operator": "=",
                "value": filtroWidget.currentRow.ENTRINI
            },
            {
                "name": "P_ENTRFIM",
                "operator": "=",
                "value": filtroWidget.currentRow.ENTRFIM
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        
        widget.reload();
    };
    
    this.controlaFieldSolicitacao = function(field) {
        const widget = field.widget;
        if(widget.currentRow.CDFILIAL_SOL) {
            widget.getField("NRSOLICMP_SOL").readOnly = false;
            if(widget.currentRow.NRSOLICMP_SOL)
                widget.getField("NRSOLICMP_SOL").clearValue();
            this.validaFieldSolicitacao(widget.getField("NRSOLICMP_SOL"));
        } else {
            widget.getField("NRSOLICMP_SOL").readOnly = true;
            if(widget.currentRow.NRSOLICMP_SOL)
                widget.getField("NRSOLICMP_SOL").clearValue();
        }
        widget.getField("NRSOLICMP_SOL").reload();
    };
    
    this.validaFieldSolicitacao = function(field) {
        field.dataSourceFilter = [
            {
                "name":"CDFILSOLI",
                "operator": "=",
                "value": field.widget.currentRow.CDFILIAL_SOL
            },
            {
                "name":"NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        field.reload();
    };
    
    this.validaDestinoSolicitacao = function(field){
        field.dataSourceFilter = [
            {
                "name":"P_CDFILIAL",
                "operator": "=",
                "value": field.widget.currentRow.CDFILIAL
            }
        ];
        field.reload();
    };
    
    this.adicionaSolicitacao = function() {
        const solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        const inclusaoSolicitacao = templateManager.container.getWidget("inclusaoSolicitacao");
        const principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        const diasEntrega = templateManager.container.getWidget("DATAS");
        
        inclusaoSolicitacao.isVisible = true;
        inclusaoSolicitacao.activate();
        principal.enabled = true;
        principal.isVisible = true;
        principal.template = "widget/form.html";
        diasEntrega.enabled = true;
        diasEntrega.isVisible = true;
        diasEntrega.template = "widget/grid.html";
        principal.activate();
        General.edit(principal);
        delete principal.getField("NMPRODINI").validations;
        delete principal.getField("NMPRODFIN").validations;
        principal.getField("NMPRODINI").reload();
        principal.getField("NMPRODFIN").reload();
        
        templateManager.container.getWidget("dadosSolicitacao").enabled = false;
        templateManager.container.getWidget("produtosWidget").enabled = false;
        templateManager.container.getWidget("justificativaAlteracao").enabled = false;
        principal.currentRow.NRSOLICMP_SOL = "";
        principal.currentRow.NMPRODINI = "";
        principal.currentRow.NMPRODFIN = "";
        principal.currentRow.NMOPERADOR = "";
        principal.currentRow.DSJUSTSOL = "";
        principal.currentRow.CDPRODINI = "";
        principal.currentRow.CDPRODFIN = "";
        principal.currentRow.CDOPERADOR = "";
        principal.currentRow.CDJUSTSOL = "";
        
        principal.currentRow.CDFILIAL = solicitacaoWidget.currentRow.CDFILSOLI;
        principal.currentRow.CDFILSOLI = solicitacaoWidget.currentRow.CDFILSOLI;
        principal.currentRow.NMFILIAL = solicitacaoWidget.currentRow.NMFILIAL;
        principal.currentRow.CDFILCENT = solicitacaoWidget.currentRow.CDFILCENTCMP;
        principal.currentRow.CDFILCENTCMP = solicitacaoWidget.currentRow.CDFILCENTCMP;
        principal.currentRow.NMFILCENT = solicitacaoWidget.currentRow.CDFILCENTCMP+ " | " +solicitacaoWidget.currentRow.NMCENTCMP;
        principal.currentRow.IDUTAPROVSOL = solicitacaoWidget.currentRow.IDUTAPROVSOL;
        principal.currentRow.IDPERALTSAPR = solicitacaoWidget.currentRow.IDPERALTSAPR;
        principal.currentRow.IDSISDOS = solicitacaoWidget.currentRow.IDSISDOS;
    };
    
    this.preparaCurrentRowDadosSolicitacao = function(){
        var widget          = templateManager.container.getWidget('dadosSolicitacao');
        var widSolicita     = templateManager.container.getWidget('solicitacaoWidget');
        var OLD_CDFILSOLI   = widSolicita.currentRow.CDFILSOLI;
        var OLD_CDFILLANCA  = widSolicita.currentRow.CDFILLANCA;
        var OLD_NRSOLICMP   = widSolicita.currentRow.NRSOLICMP;
        
        
        widget.currentRow.OLD_CDFILSOLI  = OLD_CDFILSOLI;
        widget.currentRow.OLD_CDFILLANCA = OLD_CDFILLANCA;
        widget.currentRow.OLD_NRSOLICMP  = OLD_NRSOLICMP;
    };
    
    
    this.readOnlyJustificativa = function(widget) {
        if(widget.currentRow.EXTRA) {
            widget.getField("CDJUSTSOL").readOnly    = false;
            widget.getField("CDJUSTSOL").validations = {required: true};
        } else {
            widget.getField("CDJUSTSOL").readOnly    = true;
            widget.getField("CDJUSTSOL").value("");
            widget.getField("CDJUSTSOL").validations = {};
        }
    };
    
    this.excluiData = function(row, widget) {
        var rows    = widget.dataSource.data;
        var auxRows = [];
        
        for(var i = 0; i < rows.length; i++) {
            if(row.DTPROGENTR !== rows[i].DTPROGENTR) {
                auxRows.push(rows[i]);
            }
        }
        
        widget.dataSource.data = auxRows;
        widget.reload();
    };

    
    this.nivelCompletoProduto = function() {
        return General.getLevelByMask('GER_CDPICTPROD','1').length;
    };
    
    
    
    this.setReadOnlyAddDateFields = function (widget) {
        if (widget.currentRow.CDPRODUTO) {
            setDataFieldReadOnly(widget, false);
        } else {
            setDataFieldReadOnly(widget, true);
        }
    };
    
    /*this.abreDetalhesProduto = function(widget) {
        var widDetalhesProduto  = templateManager.container.getWidget("detalhesProduto");
        var widSolicitacao      = templateManager.container.getWidget("solicitacaoWidget");
        
        widget.currentRow.CDFILSOLI  = widSolicitacao.currentRow.CDFILSOLI;
        widget.currentRow.CDFILLANCA = widSolicitacao.currentRow.CDFILLANCA;
        widget.currentRow.NRSOLICMP  = widSolicitacao.currentRow.NRSOLICMP;
        
        ScreenService.openSwipe(widDetalhesProduto);
    };*/
    
    /*this.carregarDetalhesProduto = function(widget){
        widget.dataSourceFilter = [
            {
                "name": "P_NRSOLICMP",
                "operator": "=",
                "value": widget.getParent().currentRow.NRSOLICMP
            },
            {
                "name": "P_CDFILLAN",
                "operator": "=",
                "value": widget.getParent().currentRow.CDFILLANCA
            },
            {
                "name": "P_CDPRODUTO",
                "operator": "=",
                "value": widget.getParent().currentRow.CDPRODUTO
            },
            {
                "name": "P_CDFILSOLI",
                "operator": "=",
                "value": widget.getParent().currentRow.CDFILSOLI
            },
            {
                "name": "P_NRTIPOCUSTO",
                "operator": "=",
                "value":templateManager.container.getWidget('filtroWidget').currentRow.CDTIPOCUSTO
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        widget.unSelectAll();
        widget.reload();
    };*/
    
    self.validaData = function(widget){
        var bool = true;
        widget.getParent().dataSource.data.forEach(function(data){
            if(widget.currentRow.DTPROGENTR == data.DTPROGENTR.substr(0, 10)){
                bool = false;
            }
        });
        return bool;
    };
    
    this.salvaData = function(widget) {
        var filtroWidget      = templateManager.container.getWidget('filtroWidget');
        var solicitacaoWidget = templateManager.container.getWidget('solicitacaoWidget');
        var widStripe         = templateManager.container.getWidget('STRIPE');
        var widProdutos       = templateManager.container.getWidget('produtos');
        
        if (widStripe.dataSource.data[0].IDUTAPROVSOL == 'N') {
            widget.currentRow.IDSOLIAPROV = 'S';
        } else {
            if(widStripe.dataSource.data[0].IDPERALTSAPR[0] == 'S'){
                widget.currentRow.IDSOLIAPROV = 'S';
            }else{
                widget.currentRow.IDSOLIAPROV = 'N';
            }
        }
        
        widget.currentRow.IDSOLIAPROV   = getAprovacaoSolicitacao(widget.currentRow);
            
        widget.currentRow.CDFILIAL      = filtroWidget.currentRow.CDFILIAL;
        widget.currentRow.CDFILSOLI     = solicitacaoWidget.currentRow.CDFILSOLI;
        widget.currentRow.NRSOLICMP     = solicitacaoWidget.currentRow.NRSOLICMP;
        widget.currentRow.CDPRODUTO     = widProdutos.currentRow.CDPRODUTO;
        widget.currentRow.CDFILLANCA      = solicitacaoWidget.currentRow.CDFILLANCA;
        widget.currentRow.CDOPERLANC    = solicitacaoWidget.currentRow.CDOPERLANC;
        widget.currentRow.CDOPERADOR    = solicitacaoWidget.currentRow.CDOPERLANC;
        widget.currentRow.DSJUSTOPER    = !widget.currentRow.DSJUSTOPER ? null : widget.currentRow.DSJUSTOPER;
        widget.currentRow.__isNew       = true;
        widget.currentRow.TXOBSITMSOL   = !widget.currentRow.TXOBSITMSOL ? null : widget.currentRow.TXOBSITMSOL;
        widget.currentRow.DTCMPANTERIOR = !widget.currentRow.DTCMPANTERIOR ? null : widget.currentRow.DTCMPANTERIOR;
        widget.currentRow.QTVOLUITEMSO  = !widget.currentRow.QTVOLUITEMSO ? null : widget.currentRow.QTVOLUITEMSO;
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProd','Row', widget.currentRow).then(function(res){
            ScreenService.closePopup(true);
            ScreenService.notificationMessage("Salvo com sucesso!","success");
            templateManager.container.getWidget('detalhesProduto').reload();
            templateManager.container.getWidget('detalhesProduto').activate();
            self.produtosReload();
            widget.currentRow = {};
        });
    };
    
    this.backProdutos = function() {
        const produtosWidget = templateManager.container.getWidget('produtosWidget');
        
        ScreenService.closeSwipe();
        produtosWidget.unSelectAll();
        produtosWidget.reload();
    };
    
    this.limpaDestinoSoli = function() {
        
        let widget = templateManager.container.getActiveWidget();
        
        widget.getField('NMDESTSOLI').clearValue();
     
    };
    
    
    this.openTelaAprovacao = function() {
        var widget = templateManager.container.getWidget("filtroWidget");
        // ScreenService.openWindow('cmp_solicitacao_solicitacaoCompras#/cmp06400aprovacao_desaprovacao_solicitacao_compras').then(function() {
        //     var widAprovacao = templateManager.container.getActiveWidget();
        // 	var filterRow = {
        //             "DTENTREGA" : widget.currentRow.DTENTREGA ,
        //             "DTSOLICITACAO" : widget.currentRow.DTSOLICITACAO,
        //             "NMGRUPFILI" : widget.currentRow.NMGRUPFILI ,
        //             "CDGRUPFILI" : widget.currentRow.CDGRUPFILI,
        //             "CDFILIAL" : widget.currentRow.CDFILIAL ,
        //             "NMFILIAL" : widget.currentRow.NMFILIAL,
        //             "NRSOLI" : widget.container.getWidget('STRIPE').currentRow.NRSOLICMP,
        //             'ENTREGA': [
        // 	    		'ED',
        // 	    		'OL'
        // 	    	]
        // 	 };
        //      Utilities.startFilter(widAprovacao, filterRow);
        // });
        
        $http.get('assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/json/containers/cmp06400aprovacao_desaprovacao_solicitacao_compras.json').then(function(result) {
			var containerAprovacaoDesaprovacao = this.containerFactory(result.data);
			const filtro = templateManager.container.getWidget('dadosSolicitacao').externalRow;
			templateManager.container = containerAprovacaoDesaprovacao;
			onEnterAprovacaoDesaprovacao(templateManager.container.getWidget("cmp06400aprovacao_desaprovacao_grid"), filtro);
		}.bind(metaDataFactory), function(error) {
			throw error;
		});
    };
    
    function onEnterAprovacaoDesaprovacao(externWidget, dados) {
        dados.IDOPERACAO = 'R';
        
        externWidget.externParams = dados;
    }
    
    this.carregaGridJustificativa = function(widget){
        var widSolicitacao      = templateManager.container.getWidget('solicitacaoWidget');
        widget.dataSourceFilter = [
            {
                "name": "P_CDFILSOLMOV",
                "operator": "=",
                "value": widSolicitacao.currentRow.CDFILSOLI
            },
            {
                "name": "P_CDFILLANMOV",
                "operator": "=",
                "value": widSolicitacao.currentRow.CDFILLANCA
            },
            {
                "name": "P_NRSOLIMOV",
                "operator": "=",
                "value": widSolicitacao.currentRow.NRSOLICMP
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }
        ];
        
        widget.reload();
    };
    
    this.limpaFields = function(widget){
        //widget.currentRow = {};
        widget.backupRow = widget.currentRow;
        validaCamposAddDataInclusaoCotacao(widget);
    };
    
    function validaCamposAddDataInclusaoCotacao(widget) {
        const widgetProduto = templateManager.container.getWidget('prodnovo');
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validarInclusProdCompra','Row', widgetProduto.currentRow).then(function(res){
            let dados = res.dataset.res[0];
            
            let fieldDataCompraAnterior = widget.getField('DTCMPANTERIOR');
            let fieldObservacao = widget.getField('TXOBSITMSOL');
            
            if(dados[0].IDAPROVITMSOLGR == 'S'){
                fieldDataCompraAnterior.isVisible = true;
                fieldDataCompraAnterior.validations = {"required": true};
                fieldObservacao.isVisible = true;
            }else{
                delete fieldDataCompraAnterior.validations;
                fieldDataCompraAnterior.isVisible = false;
                fieldObservacao.isVisible = false;
            }
            
            templateManager.updateTemplate();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.abreDetalhesJustificativas = function(widget) {
        widget.backupRow = angular.copy(widget.currentRow);
        
        var activeWidget = templateManager.container.getActiveWidget();
        
        if(templateManager.container.getWidget("stripeWidget").currentRow.IDUTLOPERSOL == 'S') {
            widget.view();
            widget.getAction('voltar').isVisible = true;
        } else {
		    widget.getAction('editaJustificativa').isVisible = true;
        }
        
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
        } else {
            widget.getField("DSJUSTOPER").template = "field/text-edit.html";
        }
        
        widget.redraw();
    };
    
    this.editaJustificativa = function(widget) {
	    widget.edit();
    }; 
    
    this.salvaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPER = widget.currentRow.DSJUSTOPER ? widget.currentRow.DSJUSTOPER : null;
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvaJustificativa', 'Row', widget.currentRow).then(function(success) {
            ScreenService.closeSwipe();
    		widget.list();
    		widget.activate();
    		ScreenService.notificationMessage("Salvo com sucesso!", "success");
        });
    };
    
    this.cancelaJustificativa = function(widget) {
        ScreenService.closeSwipe().then(function() {
    		widget.reload();
    		widget.list();
    		widget.activate();
        });
    };
    
    this.cancelaEditQuantidade = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
        widget.getAction("CALCULO_MEDIA").isVisible = true;
    };
    
    this.cancelaEditQuantidade = function(widget) {
        widget.commitInlineEdit();
        widget.list();
        widget.getAction("CALCULO_MEDIA").isVisible = true;
    };
    
    //adcionar solicitação
    
    this.abreDetalhesProdNovo        = function(widget) {
        var widDetalhesProduto       = templateManager.container.getWidget("detalhesProdNovo");
        var widSolicitacao           = templateManager.container.getWidget("solicitacaoWidget");
        var widIncluSolicita         = templateManager.container.getWidget("principal");
        var widDatas                 = templateManager.container.getWidget("DATAS");
        
        widget.currentRow.CDFILSOLI  = widIncluSolicita.currentRow.CDFILSOLI;
        widget.currentRow.CDFILLANCA = widIncluSolicita.currentRow.CDFILLANCA;
        widget.currentRow.NRSOLICMP  = widIncluSolicita.currentRow.NRSOLICMP;
        widget.currentRow.NRORG      = getLocalVar('NRORG');
        
        var diasEntrega              = widDatas.dataSource.data;
        
        if(widget.dataSource.data[widget.currentRow.__index].__isNew == false){
            
            return General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/selectDetalhesProduto','Row', widget.currentRow).then(function(res){
                var dados                           = res;
                widDetalhesProduto.dataSource.data  = dados.dataset.res[0];
                var ar                              = [];
        
                for(var k = 0; k < widDetalhesProduto.dataSource.data.length; k++){
                	for(var j = 0; j < ar.length; j++){
                		if(widDetalhesProduto.dataSource.data[k].DTPROGENTR.substr(0, 10) == ar[j].DTPROGENTR){   
                			ar.push(widDatas.dataSource.data.slice(j, 1));
                		}
                	}
                }
                for(var l = 0; l < ar.length; l++){
                    widDetalhesProduto.dataSource.data.push(ar[l]);
                }
                ScreenService.openSwipe(widDetalhesProduto);
            }); 
        }else{
            days.forEach(function(dias) {
                dias.forEach(function(dia){
                    dia.QTSOLIPROD = 0; 
                    dia.__isNew = true;    
                });
                if(dias.CDARVPROD == widget.currentRow.CDARVPROD){
                    widDetalhesProduto.dataSource.data = dias;
                }
            });
            
            ScreenService.openSwipe(widDetalhesProduto); 
        }
    };
    
    this.adicionaProdNovo = function() {
        const widgetProdNovo = templateManager.container.getWidget("adicionaProdNovo");
        const widgetGridDatasProdNovo = templateManager.container.getWidget("datasAddProdNovo");
        
        widgetProdNovo.currentRow.CDPRODUTO     = "";
        widgetProdNovo.currentRow.NMPRODUTO     = "";
        
        widgetGridDatasProdNovo.dataSource.data = [];
        
        setDataFieldReadOnly(templateManager.container.getWidget('adicionaProdNovo'), true);
        
        ScreenService.openSwipe(widgetProdNovo);
    };
    
    this.excluiProdNovo = function(widget) {
        var dataToQuery = [];
        var principal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        for(var i = 0; i < widget.getCheckedRows().length; i++){
        	for(var j = 0; j < widget.dataSource.data.length; j++){
        		if(widget.dataSource.data[j]){
        		    if(!widget.getCheckedRows()[i].__isNew){
                        widget.dataSource.data[j].CDFILSOLI  = principal.currentRow.CDFILSOLI;
                        widget.dataSource.data[j].CDFILLANCA = principal.currentRow.CDFILLANCA;
                        widget.dataSource.data[j].NRSOLICMP  = principal.currentRow.NRSOLICMP;
                        widget.dataSource.data[j].NRORG      = getLocalVar('NRORG');
                        
                        if(widget.dataSource.data[j].__isSelected == true){
                            dataToQuery.push(widget.dataSource.data[i]);
                        }
            	    }
                    if(widget.getCheckedRows()[i].CDARVPROD == widget.dataSource.data[j].CDARVPROD)		 {
                        widget.dataSource.data.splice(j, 1);
                    }
                }
            }
        }
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/verificaDetalhesProduto','Row', dataToQuery).then(function(success){
            ScreenService.notificationMessage('Excluido com sucesso');
            widget.updateCheckedRows();
        });
    };
    
    this.cancelaEditProdNovo = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
     
    };
    
    this.salvaEditProdNovo = function(widget) {
        var dataRowNew = [];
        var dataRowOld = [];
        var widStripe = templateManager.container.getWidget('STRIPE');
        for(var i = 0; i < widget.dataSource.data.length; i++){
            widget.dataSource.data[i].CDFILIAL       = templateManager.container.getWidget('principal').currentRow.CDFILIAL;
            widget.dataSource.data[i].CDFILSOLI      = templateManager.container.getWidget('principal').currentRow.CDFILSOLI;
            widget.dataSource.data[i].NRSOLICMP      = widget.getParent().currentRow.NRSOLICMP;
            widget.dataSource.data[i].CDPRODUTO      = widget.getParent().currentRow.CDPRODUTO;
            widget.dataSource.data[i].CDFILLANCA       = templateManager.container.getWidget('principal').currentRow.CDFILLANCA;
            widget.dataSource.data[i].TXOBSITMSOL    = null;
            widget.dataSource.data[i].DTCMPANTERIOR  = null;
            widget.dataSource.data[i].NRORG          = getLocalVar('NRORG');
            widget.dataSource.data[i].CDOPERADOR     = templateManager.container.getWidget('principal').currentRow.CDOPERADOR;
            widget.dataSource.data[i].CDOPERLANC     = templateManager.container.getWidget('principal').currentRow.CDOPERADOR;
            widget.dataSource.data[i].DSJUSTOPER     = null;
            widget.dataSource.data[i].OLD_QTSOLIPROD = widget.dataSource.data[i].changed_QTSOLIPROD;
            widget.dataSource.data[i].QTVOLUITEMSO   = widget.dataSource.data[i].QTVOLUITEMSO ? widget.dataSource.data[i].QTVOLUITEMSO : 0;
            
            const parameters = widStripe.dataSource.data[0] || widStripe.dataSource.data[1];
            
            if (parameters.IDUTAPROVSOL == 'N') {
                widget.dataSource.data[i].IDSOLIAPROV = 'S';
            } else {
                if (parameters.IDPERALTSAPR[0] == 'S'){
                    widget.dataSource.data[i].IDSOLIAPROV = 'S';
                }else{
                    widget.dataSource.data[i].IDSOLIAPROV = 'N';
                }
            }
            
            if (paramGeral.IDSISDOS == '3') {
                widget.dataSource.data[i].IDSOLIAPROV = getAprovacaoSolicitacaoGR(widget.dataSource.data[i], parameters);
            } else {
                widget.dataSource.data[i].IDSOLIAPROV = getAprovacaoSolicitacao(widget.dataSource.data[i]);
            }
            
            if(widget.dataSource.data[i].changed == true){
                if(widget.dataSource.data[i].__isNew == true){
                    dataRowNew.push(widget.dataSource.data[i]);
                    ScreenService.closeSwipe();
                    widget.getParent().activate();
                }else{
                    dataRowOld.push(widget.dataSource.data[i]);
                }
            }
        }
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProdNovo','Row', dataRowNew).then(function(success) {
            widget.getParent().dataSource.data[widget.getParent().currentRow.__index].__isNew = false;
            widget.dataSource.data[widget.currentRow.__index].__isNew               = false;
        }, function(error) {
		    MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT', null, { type: 'ERROR' });
		});
        
        General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarQuantidadeProd','Row', dataRowOld);
        
        widget.getParent().currentRow.ALTER = true;
        widget.commitInlineEdit();
        widget.list();
        widget.getParent().activate();
    };
    
    this.adicionaDataProdNovo = function() {
        var widget = templateManager.container.getWidget("adicionaDataProdNovo");
        ScreenService.openPopup(widget);
    };
    
    this.excluiDataProdNovo = function(widget) {
        var dataRow = [];
        
        if(widget.getParent().currentRow.__isNew){
            widget.dataSource.data.forEach(function(data, key){
                if(data.__isSelected){
                    widget.dataSource.data.splice(key, 1);
                }
            });
        }else{
            for(var i = 0; i < widget.dataSource.data.length; i++){
                widget.dataSource.data[i].CDFILSOLI = widget.getParent().currentRow.CDFILSOLI;
                widget.dataSource.data[i].CDPRODUTO = widget.getParent().currentRow.CDPRODUTO;
                widget.dataSource.data[i].NRSOLICMP = widget.getParent().currentRow.NRSOLICMP;
                widget.dataSource.data[i].CDFILLANCA  = widget.getParent().currentRow.CDFILLANCA;
                widget.dataSource.data[i].NRORG  = getLocalVar('NRORG');
                if(widget.dataSource.data[i].__isSelected == true){
                    dataRow.push(widget.dataSource.data[i]);
                }
            }
            
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/deleteQuantidadeProd', 'Row', dataRow).then(function(success) {
                widget.reload();
            });
        }
    };
    
    function verifyExistsProdNovoAndDate() {
        const produtosWidget = templateManager.container.getWidget("prodnovo");
        const adicionaProduto = templateManager.container.getWidget("adicionaProdNovo");
        
        return produtosWidget.dataSource.data.filter(value => value.CDPRODUTO === adicionaProduto.currentRow.CDPRODUTO && moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    function verifyExistsNovoDate() {
        const adicionaProduto = templateManager.container.getWidget("adicionaProdNovo");
        const datasAddProduto = templateManager.container.getWidget("datasAddProdNovo");
        
        return datasAddProduto.dataSource.data.filter(value => moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
    }
    
    this.addDataProdNovo = function() {
        const datasAddProduto = templateManager.container.getWidget("datasAddProdNovo");
        const adicionaProduto = templateManager.container.getWidget("adicionaProdNovo");
        const inclSolWidget = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        const selectedDate = adicionaProduto.currentRow.DTPROGENTR;
        
        if(adicionaProduto.currentRow && adicionaProduto.currentRow.DTPROGENTR) {
            General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/validaDataProcessamento', 'Row', inclSolWidget.currentRow).then(function(res) {
                const dado = res.dataset.res[0][0].DTPROCESSA;
                const dataProcessamento = moment(dado, "DD/MM/YYYY").format("DD/MM/YYYY");
                if(adicionaProduto.currentRow.DTPROGENTR >= dataProcessamento) {
                    const numDayWeek = moment(adicionaProduto.currentRow.DTPROGENTR, "DD/MM/YYYY").weekday();
                    const daysOfWeek = ["WEEK_SUNDAY", "WEEK_MONDAY", "WEEK_TUESDAY", "WEEK_WEDNESDAY", "WEEK_THURSDAY", "WEEK_FRIDAY", "WEEK_SATURDAY"];
            
                    MessageService.getMessageByCode(daysOfWeek[numDayWeek]).then(dayOfWeek => {
                    if(verifyExistsProdNovoAndDate()) {
                        if(verifyExistsNovoDate()) {
                            datasAddProduto.dataSource.data.push({
                                "DTPROGENTR": adicionaProduto.currentRow.DTPROGENTR,
                                "SEMANA"    : dayOfWeek
                            });
                            adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                            adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                            adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                        } else {
                            MessageService.showMessageByCode('DATE_ALREADY_INFORMED', null, Constants.errorMessage);
                            adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                            adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                            adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                        }
                    } else {
                        MessageService.showMessageByCode('EXISTS_PRODUCT_DATE', null, Constants.errorMessage);
                        adicionaProduto.getField("DTPROGENTR").value(moment(selectedDate, "DD/MM/YYYY").add(1, 'days'));
                        adicionaProduto.getField("DTPROGENTR").currentDate = moment(selectedDate, "DD/MM/YYYY").add(1, 'days');
                        adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                    }
                });
                datasAddProduto.reload();
                } else {
                    MessageService.showMessageByCode("DTPROGENTR_MAIOR_DTPROCESSA", { "DATA": dataProcessamento });
                    adicionaProduto.getField("DTPROGENTR").value(dataProcessamento);
                    adicionaProduto.getField("DTPROGENTR").currentDate = dataProcessamento;
                    adicionaProduto.getField("DTPROGENTR").element[0].value = adicionaProduto.currentRow.DTPROGENTR;
                }
            }).catch(function(error) {
                console.log(error);
            });
        } else {
            MessageService.showMessageByCode("INVALID_DATA");
            return false;
        }
    };
    
    this.cancelaAddProdNovo = function(args) {
        ScreenService.closeSwipe();
        templateManager.container.getWidget("prodnovo").activate();
    };
    
    this.cancelaAddDataProdNovo = function(widget) {
        ScreenService.closePopup();
        widget.currentRow = {};
        templateManager.container.getWidget("detalhesProdNovo").activate();
    };
    
    this.salvaAddProdNovo = function(dataGrid) {
        var adicionaProduto     = templateManager.container.getWidget("adicionaProdNovo");
        var widInclusaoSolicita = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
        var produtos            = templateManager.container.getWidget("prodnovo");
        
        if(adicionaProduto.isValid()) {
            let produtosCadastrados = produtos.dataSource.data.find((produto) => produto.CDPRODUTO == adicionaProduto.currentRow.CDPRODUTO && produto.DTPROGENTR == adicionaProduto.currentRow.DTPROGENTR);
            if (!produtosCadastrados || Util.isEmptyObject(produtosCadastrados)) {
                // produtos.dataSource.data.push({
                //     "CDARVPROD": adicionaProduto.currentRow.CDARVPROD,
                //     "CDPRODUTO": adicionaProduto.currentRow.CDPRODUTO,
                //     "NMPRODUTO": adicionaProduto.currentRow.NMPRODUTO,
                //     "__isNew"  : false
                // });
                    
                for(var i = 0; i < dataGrid.dataSource.data.length; i++) {
                    dataGrid.dataSource.data[i].CDFILIAL      = widInclusaoSolicita.currentRow.CDFILIAL;
                    dataGrid.dataSource.data[i].CDFILSOLI     = widInclusaoSolicita.currentRow.CDFILSOLI;
                    dataGrid.dataSource.data[i].NRSOLICMP     = widInclusaoSolicita.currentRow.NRSOLICMP;
                    dataGrid.dataSource.data[i].CDPRODUTO     = adicionaProduto.currentRow.CDPRODUTO;
                    dataGrid.dataSource.data[i].CDARVPROD     = adicionaProduto.currentRow.CDARVPROD;
                    dataGrid.dataSource.data[i].CDFILLANCA    = widInclusaoSolicita.currentRow.CDFILLANCA;
                    dataGrid.dataSource.data[i].CDOPERADOR    = widInclusaoSolicita.currentRow.CDOPERLANC;
                    dataGrid.dataSource.data[i].CDOPERLANC    = widInclusaoSolicita.currentRow.CDOPERLANC;
                    dataGrid.dataSource.data[i].DTCMPANTERIOR = null;
                    dataGrid.dataSource.data[i].DSJUSTOPER    = "";
                    dataGrid.dataSource.data[i].TXOBSITMSOL   = null;
                    dataGrid.dataSource.data[i].NMPRODUTO     = adicionaProduto.currentRow.NMPRODUTO;
                    dataGrid.dataSource.data[i].__isNew       = true;
                    dataGrid.dataSource.data[i].QTVOLUITEMSO  = dataGrid.dataSource.data[i].QTVOLUITEMSO ? dataGrid.dataSource.data[i].QTVOLUITEMSO : 0;
                    
                    const dadosStripe = widInclusaoSolicita.currentRow;
                    
                    if (dadosStripe.IDUTAPROVSOL == 'N') {
                        dataGrid.dataSource.data[i].IDSOLIAPROV = 'S';
                    } else {
                        if (dadosStripe.IDPERALTSAPR[0] == 'S') {
                            dataGrid.dataSource.data[i].IDSOLIAPROV = 'S';
                        } else {
                            dataGrid.dataSource.data[i].IDSOLIAPROV = 'N';
                        }
                    }
                    
                    dataGrid.dataSource.data[i].IDSOLIAPROV = getAprovacaoSolicitacao(dataGrid.dataSource.data[i]);
                    
                    dataGrid.dataSource.data[i].NRORG   = getLocalVar('NRORG');
                    dataGrid.dataSource.data[i].__isNew = true;
                }
                
                for(let i = 0; i < dataGrid.dataSource.data.length; i++) {
                    if(dataGrid.dataSource.data[i].QTSOLIPROD) {
                        if(parseFloat(dataGrid.dataSource.data[i].QTSOLIPROD.replace(",", ".")) > 0) {
                            produtos.dataSource.data.push(dataGrid.dataSource.data[i]);
                        }
                    }
                }
                
                ScreenService.closeSwipe();
                produtos.activate();
                
                // General.callRestEngine('cmp_solicitacao_solicitacaoCompras#/salvarDataProdNovo', 'Row', datas).then(function(success) {
                //     ScreenService.closeSwipe();
                //     produtos.activate();    
                // }, function(error) {
                //     MessageService.showMessageByCode((error.data ? 'cmp#' + error.data.error : 'cmp#TIMEOUT'), null, { type: 'ERROR' });
                // });
            } else {
                MessageService.showMessageByCode("PRODUCT_ALREADY_REGISTERED_NO_PARAM");
            }
            //this.validaProduto(adicionaProduto.currentRow.CDPRODUTO);
        }
    };
    
    this.concluirOperacao = function(widget) {
        ScreenService.confirmMessage('Concluir processo\n Obs.: Datas com quantidades zeradas serão deletadas, continuar?', 'question', function(){
			//var stripe = templateManager.container.getWidget("STRIPE");
			var widgetPrincipal = templateManager.container.getWidget("inclusaoSolicitacaoPrincipal");
			var widDatas = templateManager.container.getWidget("DATAS");
			widget.list();
			widget.isVisible = false;
			
			//ScreenService.openPopup(templateManager.container.getWidget('solicitacaoWidget'));
			//templateManager.container.getWidget('solicitacaoWidget').activate();
			templateManager.container.getWidget("dadosSolicitacao").enabled       = true;
            templateManager.container.getWidget("produtosWidget").enabled         = true;
            templateManager.container.getWidget("produtosWidget").isVisible       = true;
            templateManager.container.getWidget("justificativaAlteracao").enabled = true;
            templateManager.container.getWidget("inclusaoSolicitacao").isVisible  = false;
            templateManager.container.getWidget("dadosSolicitacao").activate();
            //if(!stripe.dataSource.data[0]){
            //    self.abreFiltro(false);
            //}
            widDatas.dataSource.data = [];
            widDatas.getParent().currentRow = {};
            widgetPrincipal.currentRow = widgetPrincipal.backupRow;
            //stripe.getAction("abreFiltro").isVisible                              = true;
            //stripe.getAction("listaSoli").isVisible                               = true;
		});        
    };
    
    self.setNrorg = function(){
        templateManager.container.getWidget("dadosSolicitacao").currentRow.NRORG        = getLocalVar('NRORG');
        templateManager.container.getWidget("produtos").currentRow.NRORG                = getLocalVar('NRORG');
        templateManager.container.getWidget("adicionaDataProduto").currentRow.NRORG     = getLocalVar('NRORG');
        templateManager.container.getWidget("detalhesProduto").currentRow.NRORG         = getLocalVar('NRORG');
        templateManager.container.getWidget("justificativaAlteracao").currentRow.NRORG  = getLocalVar('NRORG');
        templateManager.container.getWidget("principal").currentRow.NRORG               = getLocalVar('NRORG');
        templateManager.container.getWidget("adicionaDataProdNovo").currentRow.NRORG    = getLocalVar('NRORG');
        templateManager.container.getWidget('STRIPE').currentRow.NRORG                  = getLocalVar('NRORG');
    };
    
    this.mudaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPER = "";
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPER").template = "zh-select-autocomplete#field/select-autocomplete.html";
        } else {
            widget.getField("DSJUSTOPER").template = "field/text-edit.html";
        }
        
        widget.redraw();
    };
    
    this.validaProdutoCadastrado = function (field) {
        const produtos = templateManager.container.getWidget("prodnovo");
        const widget = field.widget;
        
        // let validacao = produtos.dataSource.data.filter(value => value.CDPRODUTO === widget.currentRow.CDPRODUTO && moment(value.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY") === moment(widget.currentRow.DTPROGENTR, "DD/MM/YYYY").format("DD/MM/YYYY")).length === 0;
        
        // let produtosCadastrados = produtos.dataSource.data.find((produto) => produto.CDPRODUTO == widget.currentRow.CDPRODUTO);
        // if (produtosCadastrados && !Util.isEmptyObject(produtosCadastrados)) {
        //     MessageService.showMessageByCode("PRODUCT_ALREADY_REGISTERED_NO_PARAM");
        //     field.clearValue();
        //     field.reload();
        // } 
        
        if (widget.currentRow.CDPRODUTO) {
            setDataFieldReadOnly(widget, false);
        } else {
            setDataFieldReadOnly(widget, true);
        }
    };
    
    this.changeProdIni = function(field) {
        const widgetInclusaoSolicitacao = field.getParent();
        const currentRow = widgetInclusaoSolicitacao.currentRow;
        const fieldProdFin = widgetInclusaoSolicitacao.getField("NMPRODFIN");
        if(currentRow.CDPRODINI) {
           field.validations.required = true;
           field.reload();
           fieldProdFin.validations.required = true;
           fieldProdFin.reload();
        } else if(!currentRow.CDPRODINI) {
           delete field.validations.required;
           field.reload();
           delete fieldProdFin.validations.required;
           fieldProdFin.clearValue();
           currentRow.CDPRODINI = "";
           currentRow.CDPRODFIN = "";
           fieldProdFin.reload();
        }
    };
    
    this.goToDatasWidget = function() {
        const widgetDiasEntrega = templateManager.container.getWidget("diasEntrega");
        widgetDiasEntrega.activate();
    };
    
    this.abreLancamento = function(widget, openOnProductTab = false) {
        return new Promise((resolve, reject) => {
            const dadosSolicitacao = widget.container.getWidget("dadosSolicitacao");
            const tabbedWidget = templateManager.container.getWidget("tabbedWidget");
            
            dadosSolicitacao.currentRow = widget.currentRow;
            dadosSolicitacao.enabled = true;
            
            tabbedWidget.defaultTab = openOnProductTab ? "produtosWidget" : "dadosSolicitacao";
            
            let openFunction, params = [dadosSolicitacao];
            
            if(openOnProductTab) {
                openFunction = abreLancamentoOnProductTab;
                params.push(tabbedWidget);
            } else {
                openFunction = abreLancamentoOnDadosTab;
            }
            
            return openFunction(...params).then(() => {
                const closeAll = true;
                const enabled = true;
                
                //General.changeWidgetAcessibility(tabbedWidget, enabled);
                
                ScreenService.openSwipe(tabbedWidget, closeAll).then(function() {
                    setFieldsVisible(widget);
                }).catch(error => {
                    console.log("Error: ", error);
                });
            }).finally(() => resolve(tabbedWidget));
        });
    };
    
    function abreLancamentoOnProductTab(dadosSolicitacao, tabbedWidget) {
        return new Promise((resolve, reject) => {
            const produtosWidget = templateManager.container.getWidget("produtosWidget");
            produtosWidget.reload().then(function(data) {
                setProdStripeFooter(data);
                resolve(tabbedWidget);
            });
        });
    }
    
    function abreLancamentoOnDadosTab(dadosSolicitacao) {
        return new Promise((resolve, reject) => {
            
        });
    }
}

Configuration(function(ContextRegister){
    ContextRegister.register('cmp03100_lancamento_de_solicitacao_de_comprasController',cmp03100_lancamento_de_solicitacao_de_comprasController);
});